#include <string.h>

#include <windows.h>
#include <commctrl.h>

#include "main.h"
#include "resource.h"


BOOL DoFind( AC *ac )
{
	LPTSTR  lpszSmc;
	LPTSTR  lpszCur;
	DWORD   dwSmcSize;
	DWORD   dwStart;
	DWORD   dwEnd;
	int     nCmp;
	int     nRes;


	SendMessage( ac->hWndEdit, EM_GETSEL, (WPARAM)&dwStart, (LPARAM)&dwEnd );

	dwSmcSize = (DWORD)GetWindowTextLength( ac->hWndEdit );
	lpszSmc = (LPTSTR)calloc( dwSmcSize + 1, sizeof(TCHAR) );
	if ( lpszSmc == NULL ) {
		goto ABORT_FIND;
	}
	GetWindowText( ac->hWndEdit, lpszSmc, dwSmcSize + 1 );

	nCmp = lstrlen( ac->lpszFind );

	ac->nFindIndex = -1;
	if ( ac->bFindDir == FIND_DOWN ) {
		if ( dwEnd + nCmp > dwSmcSize ) {
			goto ABORT_FIND;
		}

		lpszCur = lpszSmc + dwEnd;

		while ( *lpszCur != '\0' ) {
			if ( ac->bFindNoCase ) {
				nRes = _memicmp( lpszCur, ac->lpszFind, nCmp );
			} else {
				nRes = memcmp( lpszCur, ac->lpszFind, nCmp );
			}
			if ( nRes == 0 ) {
				ac->nFindIndex = lpszCur - lpszSmc;
				break;
			}
			lpszCur++;
		}
	} else {
		lpszCur = lpszSmc + dwStart;

		while ( lpszCur >= lpszSmc ) {
			lpszCur--;
			if ( ac->bFindNoCase ) {
				nRes = _memicmp( lpszCur, ac->lpszFind, nCmp );
			} else {
				nRes = memcmp( lpszCur, ac->lpszFind, nCmp );
			}
			if ( nRes == 0 ) {
				ac->nFindIndex = lpszCur - lpszSmc;
				break;
			}
		}
	}
	free( lpszSmc );

	if ( ac->nFindIndex >= 0 ) {
		SendMessage( ac->hWndEdit, EM_SETSEL, ac->nFindIndex, ac->nFindIndex + nCmp );
		SendMessage( ac->hWndEdit, EM_SCROLLCARET, 0, 0 );
		return TRUE;
	}

ABORT_FIND:
	MessageBeep( (UINT)-1 );
	return FALSE;
}

LPCTSTR I2N( int n )
{
	static char szBuf[32];

	wsprintf( szBuf, "%d", n );

	return szBuf;
}

BOOL UpdateFindString( AC *ac, HWND hDlg )
{
	int nLen;
	int    nIdx;


	if ( IsDlgButtonChecked(hDlg, IDC_DOWN) == 1 ) {
		VsPutProfileInt( "Local\\VisualSpice\\FIND", "DIRECTION", FIND_DOWN );
		ac->bFindDir = FIND_DOWN;
	} else {
		VsPutProfileInt( "Local\\VisualSpice\\FIND", "DIRECTION", FIND_UP );
		ac->bFindDir = FIND_UP;
	}
	ac->bFindNoCase = IsDlgButtonChecked(hDlg, IDC_STRCASE);
	VsPutProfileInt("Local\\VisualSpice\\FIND", "NOCASE", ac->bFindNoCase );

	if ( ac->lpszFind == NULL ) {
		free( ac->lpszFind );
	}

	nLen = GetWindowTextLength( GetDlgItem(hDlg,IDC_FIND) );
	if ( nLen ) {
		nLen++;
		ac->lpszFind = malloc( nLen );
		GetDlgItemText( hDlg, IDC_FIND, ac->lpszFind, nLen );
		nIdx = SendDlgItemMessage( hDlg, IDC_FIND, CB_FINDSTRING, (WPARAM)-1, (LPARAM)ac->lpszFind );
		if ( nIdx != CB_ERR ) {
			SendDlgItemMessage( hDlg, IDC_FIND, CB_DELETESTRING, nIdx, 0 );
		}
		SendDlgItemMessage( hDlg, IDC_FIND, CB_INSERTSTRING, 0, (LPARAM)ac->lpszFind );
		SendDlgItemMessage( hDlg, IDC_FIND, CB_SETCURSEL, 0, 0 );
	} else {
		ac->lpszFind = NULL;
		SetFocus( GetDlgItem(hDlg, IDC_FIND) );

		return FALSE;
	}

	{
		LPTSTR lpszBuf = NULL;	// first realloc same malloc.
		int    nBufLen = 0;
		int    nCount;
		int    nMax = VsGetProfileInt( "Local\\VisualSpice\\FINDHIST", "MAX", 4 );

		nCount = SendDlgItemMessage( hDlg, IDC_FIND, CB_GETCOUNT, 0, 0 );
		if ( nCount > nMax ) {
			nCount = nMax;
		}
		for ( nIdx = 0; nIdx < nCount; nIdx++ ) {
			nLen = SendDlgItemMessage( hDlg, IDC_FIND, CB_GETLBTEXTLEN, nIdx, 0 ) + 1;
			if ( nBufLen < nLen ) {
				nBufLen = nLen;
				lpszBuf = realloc( lpszBuf, nBufLen );
				if ( lpszBuf == NULL ) {
					VsPutProfileInt( "Local\\VisualSpice\\FINDHIST", "COUNT", 0 );
					return TRUE;	// Warning return.
				}
			}
			SendDlgItemMessage( hDlg, IDC_FIND, CB_GETLBTEXT, (WPARAM)nIdx, (LPARAM)lpszBuf );
			VsPutProfileString( "Local\\VisualSpice\\FINDHIST", I2N(nIdx), lpszBuf );
		}
		if ( lpszBuf ) {
			free( lpszBuf );
		}
		VsPutProfileInt( "Local\\VisualSpice\\FINDHIST", "COUNT", nCount );
	}

	return TRUE;
}

BOOL CALLBACK FindDlgProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	static AC	*ac;

	switch ( uMsg ) {
	case WM_INITDIALOG:
		ac = (AC *)lParam;

		{
			int nCount;
			int nIdx;

			nCount = VsGetProfileInt( "Local\\VisualSpice\\FINDHIST", "COUNT", 0 );
			for ( nIdx = 0; nIdx < nCount; nIdx++ ) {
				SendDlgItemMessage( hDlg
								  , IDC_FIND
								  , CB_INSERTSTRING
								  , nIdx
								  , (LPARAM)VsGetProfileString( "Local\\VisualSpice\\FINDHIST", I2N(nIdx), "" )
								  );
			}
			SendDlgItemMessage( hDlg, IDC_FIND, CB_SETCURSEL, 0, 0 );

			if ( GetDlgItem(hDlg, IDC_REPLACE) ) {
				nCount = VsGetProfileInt( "Local\\VisualSpice\\REPLACEHIST", "COUNT", 0 );
				for ( nIdx = 0; nIdx < nCount; nIdx++ ) {
					SendDlgItemMessage( hDlg
									  , IDC_REPLACE
									  , CB_INSERTSTRING
									  , nIdx
									  , (LPARAM)VsGetProfileString( "Local\\VisualSpice\\REPLACEHIST", I2N(nIdx), "" )
									  );
				}
				SendDlgItemMessage( hDlg, IDC_REPLACE, CB_SETCURSEL, 0, 0 );
			}
		}
		if ( VsGetProfileInt("Local\\VisualSpice\\FIND", "DIRECTION", FIND_DOWN) == FIND_DOWN ) {
			CheckDlgButton( hDlg, IDC_DOWN, 1 );
		} else {
			CheckDlgButton( hDlg, IDC_UP, 1 );
		}
		CheckDlgButton( hDlg, IDC_STRCASE, VsGetProfileInt("Local\\VisualSpice\\FIND", "NOCASE", TRUE) );
		return TRUE;

	case WM_COMMAND:
		switch ( LOWORD(wParam) ) {
		case IDC_REPLACE:
			if ( HIWORD(wParam) == CBN_KILLFOCUS ) {
				int nLen;
				int nIdx;

				nLen = GetDlgItemText( hDlg, IDC_REPLACE, ac->szMessage, MSGBUF );
				if ( nLen ) {
					nIdx = SendDlgItemMessage( hDlg, IDC_REPLACE, CB_FINDSTRING, (WPARAM)-1, (LPARAM)ac->szMessage );
					if ( nIdx != CB_ERR ) {
						SendDlgItemMessage( hDlg, IDC_REPLACE, CB_DELETESTRING, nIdx, 0 );
					}
					SendDlgItemMessage( hDlg, IDC_REPLACE, CB_INSERTSTRING, 0, (LPARAM)ac->szMessage );
					SendDlgItemMessage( hDlg, IDC_REPLACE, CB_SETCURSEL, 0, 0 );
				}
			}
			break;

		case IDC_NEXT:
		case IDOK:
			if ( UpdateFindString(ac, hDlg) == FALSE ) {
				return TRUE;
			}
			if ( LOWORD(wParam) == IDOK ) {
				EndDialog( hDlg, IDOK );
			} else {
				if ( DoFind(ac) == FALSE ) {
					wsprintf( ac->szMessage, "\"%s\"܂łB", ac->lpszFind );
					MessageBox( hDlg, ac->szMessage, "VisualSpice - u", MB_OK );
				}
			}
			return TRUE;

		case IDC_DO:
			{
				DWORD dwStart;
				DWORD dwEnd;

				SendMessage( ac->hWndEdit, EM_GETSEL, (WPARAM)&dwStart, (LPARAM)&dwEnd );
				if ( dwStart == dwEnd ) {
					MessageBeep( (UINT)-1 );
					return TRUE;
				}
			}
			if ( GetDlgItemText(hDlg, IDC_REPLACE, ac->szMessage, MSGBUF) == 0 ) {
				lstrcpy( ac->szMessage, "" );
			}
			SendMessage( ac->hWndEdit, EM_REPLACESEL, 0, (LPARAM)ac->szMessage );
			if ( DoFind(ac) == FALSE ) {
				wsprintf( ac->szMessage, "\"%s\"܂łB", ac->lpszFind );
				MessageBox( hDlg, ac->szMessage, "VisualSpice - u", MB_OK );
			}
			return TRUE;

		case IDC_DOALL:
			if ( UpdateFindString(ac, hDlg) == FALSE ) {
				return TRUE;
			}
			if ( GetDlgItemText(hDlg, IDC_REPLACE, ac->szMessage, MSGBUF) == 0 ) {
				lstrcpy( ac->szMessage, "" );
			}
			while ( DoFind(ac) ) {
				SendMessage( ac->hWndEdit, EM_REPLACESEL, 0, (LPARAM)ac->szMessage );
			}
			wsprintf( ac->szMessage, "\"%s\"̒u͏I܂B", ac->lpszFind );
			MessageBox( hDlg, ac->szMessage, "VisualSpice - u", MB_OK );
			return TRUE;

		case IDCANCEL:
			if ( GetDlgItem(hDlg, IDC_REPLACE) ) {
				LPTSTR lpszBuf = NULL;	// first realloc same malloc.
				int    nBufLen = 0;
				int    nIdx;
				int    nLen;
				int    nCount;
				int    nMax = VsGetProfileInt( "Local\\VisualSpice\\REPLACEHIST", "MAX", 4 );

				nCount = SendDlgItemMessage( hDlg, IDC_REPLACE, CB_GETCOUNT, 0, 0 );
				if ( nCount > nMax ) {
					nCount = nMax;
				}
				for ( nIdx = 0; nIdx < nCount; nIdx++ ) {
					nLen = SendDlgItemMessage( hDlg, IDC_REPLACE, CB_GETLBTEXTLEN, nIdx, 0 ) + 1;
					if ( nBufLen < nLen ) {
						nBufLen = nLen;
						lpszBuf = realloc( lpszBuf, nBufLen );
						if ( lpszBuf == NULL ) {
							VsPutProfileInt( "Local\\VisualSpice\\REPLACEHIST", "COUNT", 0 );
							return TRUE;	// Warning return.
						}
					}
					SendDlgItemMessage( hDlg, IDC_REPLACE, CB_GETLBTEXT, (WPARAM)nIdx, (LPARAM)lpszBuf );
					VsPutProfileString( "Local\\VisualSpice\\REPLACEHIST", I2N(nIdx), lpszBuf );
				}
				if ( lpszBuf ) {
					free( lpszBuf );
				}
				VsPutProfileInt( "Local\\VisualSpice\\REPLACEHIST", "COUNT", nCount );
			}
			EndDialog( hDlg, IDCANCEL );
			return TRUE;
		}
		break;
	}
	return FALSE;
}

int Find( AC *ac )
{
	return DialogBoxParam( ac->hInst, MAKEINTRESOURCE(IDD_FIND), ac->hWndMain, FindDlgProc, (LPARAM)ac );
}

void Replace( AC *ac )
{
	DialogBoxParam( ac->hInst, MAKEINTRESOURCE(IDD_REPLACE), ac->hWndMain, FindDlgProc, (LPARAM)ac );
}
