#include <windows.h>
#include <shlobj.h>
#include <winnetwk.h>

#include "main.h"
#include "resource.h"


LPCTSTR SelectHtml( HWND hWndParent, LPCTSTR lpszTitle, int nID )
{
	static TCHAR        szPath[MAX_PATH];
	       OPENFILENAME ofn;


	GetDlgItemText( hWndParent, nID, szPath, MAX_PATH );

	ofn.lStructSize       = sizeof(OPENFILENAME);
	ofn.hwndOwner         = hWndParent;
	ofn.hInstance         = NULL;
	ofn.lpstrFilter       = "HTMLt@C(*.htm)\0*.htm\0ׂẴt@C(*.*)\0*.*\0";
	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter    = 0;
	ofn.nFilterIndex      = 1;
	ofn.lpstrFile         = szPath;
	ofn.nMaxFile          = MAX_PATH;
	ofn.lpstrFileTitle    = NULL;
	ofn.nMaxFileTitle     = 0;
	ofn.lpstrInitialDir   = NULL;
	ofn.lpstrTitle        = lpszTitle;
	ofn.Flags             = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST;
	ofn.nFileOffset       = 0;
	ofn.nFileExtension    = 0;
	ofn.lpstrDefExt       = "*.htm";
	ofn.lCustData         = 0;
	ofn.lpfnHook          = NULL;
	ofn.lpTemplateName    = NULL;

	if ( GetOpenFileName( &ofn ) == TRUE ) {
		SetDlgItemText( hWndParent, nID, szPath );
		return szPath;
	}
	return NULL;
}

LPCTSTR SelectExe( HWND hWndParent, LPCTSTR lpszTitle, int nID )
{
	static TCHAR        szPath[MAX_PATH];
	       OPENFILENAME ofn;


	GetDlgItemText( hWndParent, nID, szPath, MAX_PATH );

	ofn.lStructSize       = sizeof(OPENFILENAME);
	ofn.hwndOwner         = hWndParent;
	ofn.hInstance         = NULL;
	ofn.lpstrFilter       = "st@C(*.exe)\0*.exe\0ׂẴt@C(*.*)\0*.*\0";
	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter    = 0;
	ofn.nFilterIndex      = 1;
	ofn.lpstrFile         = szPath;
	ofn.nMaxFile          = MAX_PATH;
	ofn.lpstrFileTitle    = NULL;
	ofn.nMaxFileTitle     = 0;
	ofn.lpstrInitialDir   = NULL;
	ofn.lpstrTitle        = lpszTitle;
	ofn.Flags             = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST;
	ofn.nFileOffset       = 0;
	ofn.nFileExtension    = 0;
	ofn.lpstrDefExt       = "*.exe";
	ofn.lCustData         = 0;
	ofn.lpfnHook          = NULL;
	ofn.lpTemplateName    = NULL;

	if ( GetOpenFileName( &ofn ) == TRUE ) {
		SetDlgItemText( hWndParent, nID, szPath );
		return szPath;
	}
	return NULL;
}

// Thank's CAT-K (970826:How to Initialize SHBrowseForFolder)
int CALLBACK BrowseProc( HWND hWnd, UINT uMsg, LPARAM lParam, LPARAM lpData )
{
	switch ( uMsg ) {
	case BFFM_INITIALIZED:
		SendMessage( hWnd, BFFM_SETSELECTION, (WPARAM)TRUE, lpData );
		break;
	}

	return 0;
}

LPCTSTR SelectFolder( HWND hWndParent, LPCTSTR lpszTitle, int nID )
{
	static TCHAR        szPath[MAX_PATH];
	       BROWSEINFO   bi;
	       LPITEMIDLIST pidlRoot;
	       LPITEMIDLIST pidlSelect;


	GetDlgItemText( hWndParent, nID, szPath, MAX_PATH );

	ZeroMemory( &bi, sizeof(BROWSEINFO) );

	SHGetSpecialFolderLocation( hWndParent, CSIDL_DRIVES, &pidlRoot );
	bi.hwndOwner = hWndParent;
	bi.pidlRoot  = pidlRoot;
	bi.lpszTitle = lpszTitle;
	bi.ulFlags   = BIF_RETURNONLYFSDIRS;
	bi.lpfn      = BrowseProc;
	bi.lParam    = (LPARAM)szPath;

	pidlSelect   = SHBrowseForFolder( &bi );
	if ( pidlSelect ) {
		BOOL bRes;

		bRes = SHGetPathFromIDList( pidlSelect, szPath );
		if ( bRes ) {
			SetDlgItemText( hWndParent, nID, szPath );
			return szPath;
		}
	}
	return NULL;
}

BOOL CALLBACK FolderDlgProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	static AC *ac;
	static TCHAR szPath[MAX_PATH];


	switch ( uMsg ) {
	case WM_INITDIALOG:
		ac = (AC *)lParam;
		SetDlgItemText( hDlg, IDC_DIR_SPICE  , ac->szSpicePath   );
		SetDlgItemText( hDlg, IDC_DIR_INCLUDE, ac->szIncludePath );
		SetDlgItemText( hDlg, IDC_DIR_HELP   , ac->szSpiceHelp   );
		SetDlgItemText( hDlg, IDC_DIR_VSHELP , ac->szVSpiceHelp  );
		SetFocus( GetDlgItem(hDlg, IDC_DIR_SPICE) );
		return FALSE;

	case WM_COMMAND:
		switch ( LOWORD(wParam) ) {
		case IDOK:
			{
				UINT  nLen;

				nLen = GetDlgItemText( hDlg, IDC_DIR_SPICE, szPath, MAX_PATH );
				if ( nLen == 0 ) {
					MessageBeep( MB_OK );
					SetFocus( GetDlgItem(hDlg, IDC_DIR_SPICE) );
					return TRUE;
				}
				// w肳ꂽtH_̑݃`FbN͖ĂȂB
				lstrcpy( ac->szSpicePath, szPath );

				nLen = GetDlgItemText( hDlg, IDC_DIR_INCLUDE, szPath, MAX_PATH );
				if ( nLen == 0 ) {
					MessageBeep( MB_OK );
					SetFocus( GetDlgItem(hDlg, IDC_DIR_INCLUDE) );
					return TRUE;
				}
				// w肳ꂽtH_̑݃`FbN͖ĂȂB
				lstrcpy( ac->szIncludePath, szPath );

				nLen = GetDlgItemText( hDlg, IDC_DIR_HELP, szPath, MAX_PATH );
				if ( nLen == 0 ) {
					MessageBeep( MB_OK );
					SetFocus( GetDlgItem(hDlg, IDC_DIR_HELP) );
					return TRUE;
				}
				// w肳ꂽtH_̑݃`FbN͖ĂȂB
				lstrcpy( ac->szSpiceHelp, szPath );

				nLen = GetDlgItemText( hDlg, IDC_DIR_VSHELP, szPath, MAX_PATH );
				if ( nLen == 0 ) {
					MessageBeep( MB_OK );
					SetFocus( GetDlgItem(hDlg, IDC_DIR_VSHELP) );
					return TRUE;
				}
				// w肳ꂽtH_̑݃`FbN͖ĂȂB
				lstrcpy( ac->szVSpiceHelp, szPath );
			}
			VsPutProfileString( "Exec"  , "SMC"         , ac->szSpicePath   );
			VsPutProfileString( "Folder", "SMI"         , ac->szIncludePath );
			VsPutProfileString( "HTML"  , "SPICE"       , ac->szSpiceHelp   );
			VsPutProfileString( "HTML"  , "VisualSpice" , ac->szVSpiceHelp  );
			EndDialog( hDlg, IDOK );
			return TRUE;

		case IDCANCEL:
			EndDialog( hDlg, IDCANCEL );
			return TRUE;

		case IDC_REF_SPICE:
			SelectExe( hDlg
					 , "SPICERpCw肵ĂB"
					 , IDC_DIR_SPICE
					 );
			break;

		case IDC_REF_INCLUDE:
			SelectFolder( hDlg
						, "INCLUDEt@CT[`tH_w肵ĂB"
						, IDC_DIR_INCLUDE
						);
			break;

		case IDC_REF_HELP:
			SelectHtml( hDlg
					  , "SPICEwv}jA(HTML`)w肵ĂB"
					  , IDC_DIR_HELP
					  );
			break;

		case IDC_REF_VSHELP:
			SelectHtml( hDlg
					  , "VisualSpicewv}jA(HTML`)w肵ĂB"
					  , IDC_DIR_VSHELP
					  );
			break;
		}
	}
	return FALSE;
}

void FolderOption( AC *ac )
{
	DialogBoxParam( ac->hInst, MAKEINTRESOURCE(IDD_OPT_DIR), ac->hWndMain, FolderDlgProc, (LPARAM)ac );
}
