#include <stdio.h>
#include <string.h>
#include <limits.h>

#include <windows.h>
#include <commctrl.h>
#include <ime.h>

#include <AFXRES.H>

#include "resource.h"
#include "main.h"
#include "Splitter.h"

#if defined _EXCLUSIVE || defined _EXCLUSIVE_WITH_POPUP
BOOL ExclusiveWindow( LPCSTR lpszClassName, LPCSTR lpszTitle )
{
	HWND hPrevWnd;

	hPrevWnd = FindWindow( lpszClassName, lpszTitle );
	if ( hPrevWnd ) {
#ifdef _EXCLUSIVE_WITH_POPUP
		if ( IsIconic(hPrevWnd) ) {
			ShowWindow( hPrevWnd, SW_RESTORE );
		}
		BringWindowToTop( hPrevWnd );
		SetForegroundWindow( hPrevWnd );
#else
		MessageBeep( MB_ICONINFORMATION );
		MessageBox( NULL
					, "̃AvP[V͕Nł܂B"
					, lpszTitle
					, MB_ICONEXCLAMATION
					);
#endif
		return TRUE;
	}
	return FALSE;
}
#else
#define ExclusiveWindow(CLASS,TITLE)	FALSE
#endif


// MIDIt@ĆAISMCt@C̊gqmidɕύXm
void SetFileName( AC *ac, LPCTSTR lpszFileName )
{
	LPTSTR lpEnd;

	lstrcpy( ac->szFileName, lpszFileName );
	lstrcpy( ac->szMidiName, lpszFileName );

	lpEnd = strrchr( ac->szMidiName, '.' );
	if ( lpEnd ) {
		*lpEnd = '\0';
	}
	lstrcat( ac->szMidiName, ".mid" );
}

void SetTitle( AC *ac, BOOL bModify )
{
	static TCHAR szTitle[256];
	LPTSTR lpszTop;

	lpszTop = strrchr( ac->szFileName, '\\' );
	if ( lpszTop ) {
		lpszTop++;
	} else {
		lpszTop = ac->szFileName;
	}
	if ( bModify ) {
		wsprintf( szTitle, "VisualSpice - %s (ύX)", lpszTop );
	} else {
		wsprintf( szTitle, "VisualSpice - %s", lpszTop );
	}
	SetWindowText( ac->hWndMain, szTitle );
}

BOOL LoadSmc( AC *ac )
{
	FILE   *fp;
	long    lFileSize;
	LPTSTR  lpszSmc;

	fp = fopen( ac->szFileName, "rb" );
	if ( fp == NULL ) {
		return FALSE;
	}
	fseek( fp, 0L, SEEK_END );
	lFileSize = ftell( fp );
	rewind( fp );

	if ( lFileSize >= 30000 ) {
		OSVERSIONINFO ovi;

		ZeroMemory( &ovi, sizeof(OSVERSIONINFO) );
		ovi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
		if ( !GetVersionEx(&ovi) ) {
			// ̂Ƃ뉽̌xȂreturn
			MessageBeep( (UINT)-1 );
			fclose( fp );
			return FALSE;
		}
		if ( ovi.dwPlatformId != VER_PLATFORM_WIN32_NT ) {
			// ȉ́g64422hƂĺAJł̎l
			// ̊ł͕ς邩ȂB
			// ̒l傫Ăǂݍ߂邪AςɂȂB
			// ƂɂAGfBbgRg[ĂB
			// see ---> EditView.c
			if ( lFileSize > 64422 ) {
				MessageBox( ac->hWndMain
						  , "̃o[WWindowsł́A64422oCgȏ̃t@CҏWł܂B"
						  , "VisualSpice - SMCt@C̓ǂݍ"
						  , MB_ICONSTOP
						  );
			}
		}
	}

	lpszSmc = (LPTSTR)calloc( lFileSize + 1, sizeof(TCHAR) );
	if ( lpszSmc == NULL ) {
		fclose( fp );
		return FALSE;
	}

	fread( lpszSmc, sizeof(TCHAR), lFileSize, fp );
	fclose( fp );
	lpszSmc[lFileSize] = '\0';
	SetWindowText( ac->hWndEdit, lpszSmc );
	free( lpszSmc );

	// 30000oCgȏ̃t@CɍătHgZbgȂ
	// Ō܂ŃXN[łȂB͕sB
	SendMessage( ac->hWndEdit, WM_SETFONT, (WPARAM)ac->hFontEdit, (LPARAM)MAKELPARAM(TRUE,0) );

	ac->bModify = FALSE;

	return TRUE;
}

BOOL SaveSmc( AC *ac )
{
	FILE   *fp;
	long    lFileSize;
	LPTSTR  lpszSmc;


	lFileSize = GetWindowTextLength( ac->hWndEdit );
	lpszSmc = (LPTSTR)calloc( lFileSize + 1, sizeof(TCHAR) );
	if ( lpszSmc == NULL ) {
		return FALSE;
	}
	GetWindowText( ac->hWndEdit, lpszSmc, lFileSize + 1 );

	// BAKt@C쐬
	{
		char *lpszExt;

		lstrcpy( ac->szMessage, ac->szFileName );
		lpszExt = strrchr( ac->szMessage, '.' );
		if ( lpszExt ) {
			*lpszExt = '\0';
		}
		lstrcat( ac->szMessage, ".bak" );
		DeleteFile( ac->szMessage );
		MoveFile( ac->szFileName, ac->szMessage );
	}

	fp = fopen( ac->szFileName, "wb" );
	if ( fp == NULL ) {
		free( lpszSmc );
		return FALSE;
	}
	fwrite( lpszSmc, sizeof(TCHAR), lFileSize, fp );
	fclose( fp );
	free( lpszSmc );

	ac->bModify = FALSE;

	return TRUE;
}

void OnFileOpen( AC *ac )
{
	static TCHAR		szFileName[MAX_PATH];
	       OPENFILENAME ofn;

	ofn.lStructSize       = sizeof(OPENFILENAME);
	ofn.hwndOwner         = ac->hWndMain;
	ofn.hInstance         = ac->hInst;
	ofn.lpstrFilter       = "SMCt@C(*.smc)\0*.smc\0ׂẴt@C(*.*)\0*.*\0";
	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter    = 0;
	ofn.nFilterIndex      = 1;
	ofn.lpstrFile         = szFileName;
	ofn.nMaxFile          = 256;
	ofn.lpstrFileTitle    = NULL;
	ofn.nMaxFileTitle     = 0;
	ofn.lpstrInitialDir   = NULL;
	ofn.lpstrTitle        = "t@CJ";
	ofn.Flags             = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST;
	ofn.nFileOffset       = 0;
	ofn.nFileExtension    = 0;
	ofn.lpstrDefExt       = "*.smc";
	ofn.lCustData         = 0;
	ofn.lpfnHook          = NULL;
	ofn.lpTemplateName    = NULL;

	if ( GetOpenFileName( &ofn ) == TRUE ) {
		SetFileName( ac, szFileName );
		LoadSmc( ac );
		SetTitle( ac, FALSE );
	}
}

void OnFileSaveAs( AC *ac )
{
	static TCHAR		szFileName[MAX_PATH];
	       OPENFILENAME ofn;

	ofn.lStructSize       = sizeof(OPENFILENAME);
	ofn.hwndOwner         = ac->hWndMain;
	ofn.hInstance         = ac->hInst;
	ofn.lpstrFilter       = "SMCt@C(*.smc)\0*.smc\0ׂẴt@C(*.*)\0*.*\0";
	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter    = 0;
	ofn.nFilterIndex      = 1;
	ofn.lpstrFile         = szFileName;
	ofn.nMaxFile          = 256;
	ofn.lpstrFileTitle    = NULL;
	ofn.nMaxFileTitle     = 0;
	ofn.lpstrInitialDir   = NULL;
	ofn.lpstrTitle        = "Oĕۑ";
	ofn.Flags             = OFN_HIDEREADONLY | OFN_PATHMUSTEXIST;
	ofn.nFileOffset       = 0;
	ofn.nFileExtension    = 0;
	ofn.lpstrDefExt       = "*.smc";
	ofn.lCustData         = 0;
	ofn.lpfnHook          = NULL;
	ofn.lpTemplateName    = NULL;

	if ( GetSaveFileName( &ofn ) == TRUE ) {
		SetFileName( ac, szFileName );
		SaveSmc( ac );
		SetTitle( ac, FALSE );
	}
}

BOOL ExitCheck( AC *ac )
{
	if ( ac->bModify ) {
		int nRes;

		nRes = MessageBox( ac->hWndMain
						 , "ҏW̃t@C͕ۑĂ܂B\n\nt@Cۑ܂H"	
						 , ac->szFileName
						 , MB_ICONEXCLAMATION | MB_YESNOCANCEL
						 );

		switch ( nRes ) {
		case IDYES:
			SaveSmc( ac );
			break;

		case IDCANCEL:
			return FALSE;
		}
	}
	return TRUE;
}

// _CNg THANX to GORRY.
int Compile( AC *ac )
{
	static TCHAR                szModule[MAX_PATH];
	static TCHAR                szCommand[BUFSIZ];
	static TCHAR                szInclude[MAX_PATH];
    static STARTUPINFO          si;
    static PROCESS_INFORMATION  pi;  
	       HANDLE               hStdIn;
	       HANDLE               hStdOut;
	       HANDLE               hProcess;
		   LPTSTR               lpszTop;
	       DWORD                dwRead;
	       DWORD                dwStat;
	       BOOL                 bRes;
           SECURITY_ATTRIBUTES  satr;


	// WindowsNTpi'98.09.07)
	satr.nLength              = sizeof(SECURITY_ATTRIBUTES);
	satr.lpSecurityDescriptor = NULL;
	satr.bInheritHandle       = TRUE;


	EnableMenuItem( GetMenu(ac->hWndMain), ID_BUILD_COMPILE, MF_GRAYED );
	InitOutput( ac );
	wsprintf( ac->szMessage, "--------------------RpC: %s--------------------\r\n\r\n", ac->szFileName );
	Output( ac, ac->szMessage );

	lstrcpy( szModule, ac->szSpicePath );
	wsprintf( szCommand
			, "smc -CS%s\"%s\" \"%s\""
			, MakeOption( ac->bClock, ac->bCheck, ac->bLoop, ac->nLoop, ac->bFade, ac->nFade )
			, ac->szFileName
			, ac->szMidiName
			);
	wsprintf( szInclude, "SMC_INCLUDE=%s\0\0", ac->szIncludePath );

	bRes = CreatePipe( &hStdOut, &hStdIn, &satr, 0 );	// Default buffer size.
	if ( bRes == FALSE ) {
		MessageBeep( MB_ICONEXCLAMATION );
		wsprintf( ac->szMessage, "%sւ̃pCvɎs܂BB\r\n", szModule );
		Output( ac, ac->szMessage );
		EnableMenuItem( GetMenu(ac->hWndMain), ID_BUILD_COMPILE, MF_ENABLED );
		return -1;
	}

	si.cb          = sizeof(STARTUPINFO);
	si.lpTitle     = "SMC - SPICE\[XRpC...";
	si.dwFlags     = STARTF_USESTDHANDLES;
	si.hStdInput   = NULL;					// NULLɂWindowsNTł̃nOAbvȂ(98.09.07)
	si.hStdOutput  = hStdIn;
	si.hStdError   = hStdIn;

	bRes = CreateProcess( szModule
						, szCommand
						, NULL
						, NULL
						, TRUE
						, CREATE_DEFAULT_ERROR_MODE | CREATE_SUSPENDED | NORMAL_PRIORITY_CLASS | DETACHED_PROCESS
						, szInclude
						, NULL
						, &si
						, &pi
						);
	if ( bRes == FALSE ) {
		MessageBeep( MB_ICONEXCLAMATION );
		CloseHandle( hStdIn );
		CloseHandle( hStdOut );
		wsprintf( ac->szMessage, "%ss邽߂̃vZXɎs܂B\r\n", szModule );
		Output( ac, ac->szMessage );
		EnableMenuItem( GetMenu(ac->hWndMain), ID_BUILD_COMPILE, MF_ENABLED );
		return -1;
	}
	hProcess = OpenProcess( PROCESS_QUERY_INFORMATION | SYNCHRONIZE, FALSE, pi.dwProcessId );

	lpszTop = ac->szMessage;
	ResumeThread( pi.hThread );
	do {
		ReadFile( hStdOut, lpszTop, 1, &dwRead, NULL );
		if ( *lpszTop == '\n' ) {
			lpszTop++;
			*lpszTop = '\0';
			Output( ac, ac->szMessage );
			lpszTop = ac->szMessage;
		} else {
			lpszTop++;
		}
	} while ( WaitForSingleObject(pi.hThread,0) != WAIT_OBJECT_0 );

	GetExitCodeProcess( hProcess, &dwStat );
	CloseHandle( hStdIn );						// stdinclosereadŃubNȂۂiGORRYj

	// c̃pCvobt@óiGORRYj
	while ( ReadFile(hStdOut,lpszTop,1,&dwRead,NULL) ) {
		if ( *lpszTop == '\n' ) {
			lpszTop++;
			*lpszTop = '\0';
			Output( ac, ac->szMessage );
			lpszTop = ac->szMessage;
		} else {
			lpszTop++;
		}
	}
	CloseHandle( hProcess );
	CloseHandle( hStdOut );

	switch ( dwStat ) {
	case 0:
		MessageBeep( MB_ICONINFORMATION );
		break;

	default:
		MessageBeep( MB_ICONEXCLAMATION );
		break;
	}
	wsprintf( ac->szMessage, "\r\n\r\nI:\"%s\"\r\nXe[^X:%d\r\n", szCommand, dwStat );
	Output( ac, ac->szMessage );

	EnableMenuItem( GetMenu(ac->hWndMain), ID_BUILD_COMPILE, MF_ENABLED );

	return (int)dwStat;
}

BOOL EnableToolButton( HWND hToolBar, int nID, BOOL bEnable )
{
	return (BOOL)SendMessage( hToolBar, TB_ENABLEBUTTON, nID, MAKELPARAM(bEnable,0) );
}

void UpdateKeyStatus( HWND hWndStat )
{
	if ( GetKeyState(VK_NUMLOCK) & 0x0F ) {
		SendMessage( hWndStat, SB_SETTEXT, 1, (LPARAM)"NUM" );
	} else {
		SendMessage( hWndStat, SB_SETTEXT, 1, (LPARAM)NULL );
	}
	if ( GetKeyState(VK_CAPITAL) & 0x0F ) {
		SendMessage( hWndStat, SB_SETTEXT, 2, (LPARAM)"CAPS" );
	} else {
		SendMessage( hWndStat, SB_SETTEXT, 2, (LPARAM)NULL );
	}
	if ( GetKeyState(VK_KANA) & 0x0F ) {
		SendMessage( hWndStat, SB_SETTEXT, 3, (LPARAM)"Ji" );
	} else {
		SendMessage( hWndStat, SB_SETTEXT, 3, (LPARAM)NULL );
	}
}

void RecalcStatLayout( HWND hWndStat )
{
	RECT rectStat;
	RECT rectPart;
	int  nIdx;
	int  nTail;
	int  aWidths[4];	// It's a Magic number!!


	GetClientRect( hWndStat, &rectStat );

	nTail = rectStat.right - GetSystemMetrics(SM_CXVSCROLL);
	for ( nIdx = 3; nIdx >= 0; nIdx-- ) {
		SendMessage( hWndStat, SB_GETRECT, (WPARAM)nIdx, (LPARAM)&rectPart );
		aWidths[nIdx] = nTail;
		nTail -= 40;	// Magic! Magic!! Magic!!!
	}
	SendMessage( hWndStat, SB_SETPARTS, sizeof(aWidths) / sizeof(int), (LPARAM)aWidths );
}

void RecalcLayout( AC *ac )
{
	RECT  rect;
	RECT  rectTool;
	RECT  rectStat;
	int   nWidth;
	int   nHeight;
	int   nTop;
	int   nMid;
	int   nBottom;
	int   nSizeFrame;
	UINT  uStat;


	GetClientRect( ac->hWndMain, &rect );
	nWidth = rect.right;
	nHeight = rect.bottom;

	uStat = GetMenuState( GetMenu(ac->hWndMain), ID_VIEW_TOOLBAR, MF_BYCOMMAND );
	if ( uStat & MF_CHECKED ) {
		GetWindowRect( ac->hWndTool, &rectTool );
		nTop = rectTool.bottom - rectTool.top;
	} else {
		nTop = 0;
	}

	nSizeFrame = GetSystemMetrics( SM_CYSIZEFRAME );
	nBottom = GetSplitterPos( ac->hWndSplitter ) - nTop;
	MoveWindow( ac->hWndEdit, 0, nTop, nWidth, nBottom, TRUE );

	nMid = nBottom + GetSplitterSize( ac->hWndSplitter ) + nTop;
	uStat = GetMenuState( GetMenu(ac->hWndMain), ID_VIEW_STATUS_BAR, MF_BYCOMMAND );
	if ( uStat & MF_CHECKED ) {
		GetWindowRect( ac->hWndStat, &rectStat );
		nBottom = nHeight - nMid - (rectStat.bottom - rectStat.top);
	} else {
		nBottom = nHeight - nMid;
	}
	MoveWindow( ac->hWndOutput, 0, nMid, nWidth, nBottom, TRUE );

	if ( uStat & MF_CHECKED ) {
		nBottom = rect.bottom - (rectStat.bottom - rectStat.top);
	} else {
		nBottom = rect.bottom;
	}
	SendMessage( ac->hWndSplitter, WM_SETRANGE, (WPARAM)nTop, (LPARAM)nBottom );
}

void UpdateMenu( AC *ac )
{
	DWORD dwStart;
	DWORD dwEnd;

	// UNDO\H
	if ( SendMessage(ac->hWndEdit, EM_CANUNDO, 0, 0) ) {
		EnableMenuItem( GetMenu(ac->hWndMain), ID_EDIT_UNDO, MF_ENABLED );
		EnableToolButton( ac->hWndTool, ID_EDIT_UNDO, TRUE );
	} else {
		EnableMenuItem( GetMenu(ac->hWndMain), ID_EDIT_UNDO, MF_GRAYED  );
		EnableToolButton( ac->hWndTool, ID_EDIT_UNDO, FALSE );
	}

	// Ï̗L
	SendMessage(ac->hWndEdit, EM_GETSEL, (WPARAM)&dwStart, (LPARAM)&dwEnd );
	if ( dwStart != dwEnd ) {
		EnableMenuItem( GetMenu(ac->hWndMain), ID_EDIT_CUT   , MF_ENABLED );
		EnableMenuItem( GetMenu(ac->hWndMain), ID_EDIT_COPY  , MF_ENABLED );
		EnableMenuItem( GetMenu(ac->hWndMain), ID_EDIT_DELETE, MF_ENABLED );
		EnableToolButton( ac->hWndTool, ID_EDIT_CUT   , TRUE );
		EnableToolButton( ac->hWndTool, ID_EDIT_COPY  , TRUE );
		EnableToolButton( ac->hWndTool, ID_EDIT_DELETE, TRUE );
	} else {
		EnableMenuItem( GetMenu(ac->hWndMain), ID_EDIT_CUT   , MF_GRAYED  );
		EnableMenuItem( GetMenu(ac->hWndMain), ID_EDIT_COPY  , MF_GRAYED  );
		EnableMenuItem( GetMenu(ac->hWndMain), ID_EDIT_DELETE, MF_GRAYED  );
		EnableToolButton( ac->hWndTool, ID_EDIT_CUT   , FALSE );
		EnableToolButton( ac->hWndTool, ID_EDIT_COPY  , FALSE );
		EnableToolButton( ac->hWndTool, ID_EDIT_DELETE, FALSE );
	}
}

BOOL SelectColor( AC *ac, COLORREF *lpcr )
{
	COLORREF    acrCust[16] = {
		0x00000000,
		0x00800000,
		0x00008000,
		0x00808000,
		0x00000080,
		0x00800080,
		0x00008080,
		0x00C0C0C0,
		0x00808080,
		0x00FF0000,
		0x0000FF00,
		0x00FFFF00,
		0x000000FF,
		0x00FF00FF,
		0x0000FFFF,
		0x00FFFFFF
	};
	CHOOSECOLOR cc;

	cc.lStructSize    = sizeof(CHOOSECOLOR);
	cc.hwndOwner      = ac->hWndMain;
	cc.hInstance      = ac->hInst;
	cc.rgbResult      = *lpcr;
	cc.lpCustColors   = acrCust;
	cc.Flags          = CC_PREVENTFULLOPEN | CC_RGBINIT;
	cc.lCustData      = 0L;
	cc.lpfnHook       = NULL;
	cc.lpTemplateName = NULL;

	if ( ChooseColor(&cc) ) {
		*lpcr = cc.rgbResult;
		return TRUE;
	}
	return FALSE;
}

LRESULT CALLBACK MainWndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	static AC     thisAppContext;
	       AC    *ac = &thisAppContext;


	switch ( uMsg ) {
	case WM_CREATE:
		{
			static TBBUTTON tbTool[] = {
				{ 0,                0, (BYTE)TBSTATE_ENABLED  , (BYTE)TBSTYLE_SEP   , 0, 0 },
				//  -------------------------------------------------------------
				{  0, ID_FILE_NEW     , (BYTE)TBSTATE_ENABLED  , (BYTE)TBSTYLE_BUTTON, 0, 0 },
				{  1, ID_FILE_OPEN    , (BYTE)TBSTATE_ENABLED  , (BYTE)TBSTYLE_BUTTON, 0, 0 },
				{  2, ID_FILE_SAVE    , (BYTE)TBSTATE_ENABLED  , (BYTE)TBSTYLE_BUTTON, 0, 0 },
				{  0,                0, (BYTE)TBSTATE_ENABLED  , (BYTE)TBSTYLE_SEP   , 0, 0 },
				{  3, ID_EDIT_CUT     , (BYTE)TBSTATE_ENABLED  , (BYTE)TBSTYLE_BUTTON, 0, 0 },
				{  4, ID_EDIT_COPY    , (BYTE)TBSTATE_ENABLED  , (BYTE)TBSTYLE_BUTTON, 0, 0 },
				{  5, ID_EDIT_PASTE   , (BYTE)TBSTATE_ENABLED  , (BYTE)TBSTYLE_BUTTON, 0, 0 },
				{  0,                0, (BYTE)TBSTATE_ENABLED  , (BYTE)TBSTYLE_SEP   , 0, 0 },
				{  6, ID_EDIT_UNDO    , (BYTE)TBSTATE_ENABLED  , (BYTE)TBSTYLE_BUTTON, 0, 0 },
				{  0,                0, (BYTE)TBSTATE_ENABLED  , (BYTE)TBSTYLE_SEP   , 0, 0 },
				{ 10, ID_EDIT_FIND    , (BYTE)TBSTATE_ENABLED  , (BYTE)TBSTYLE_BUTTON, 0, 0 },
				{ 11, ID_EDIT_NEXT    , (BYTE)TBSTATE_ENABLED  , (BYTE)TBSTYLE_BUTTON, 0, 0 },
				{  0,                0, (BYTE)TBSTATE_ENABLED  , (BYTE)TBSTYLE_SEP   , 0, 0 },
				{  7, ID_BUILD_COMPILE, (BYTE)TBSTATE_ENABLED  , (BYTE)TBSTYLE_BUTTON, 0, 0 },
				{  8, ID_BUILD_PLAY   , (BYTE)TBSTATE_ENABLED  , (BYTE)TBSTYLE_BUTTON, 0, 0 },
				{  9, ID_BUILD_STOP   ,                       0, (BYTE)TBSTYLE_BUTTON, 0, 0 },
				// ܂ -------------------------------------------------------------
				{ 0,              0, (BYTE)TBSTATE_ENABLED    , (BYTE)TBSTYLE_SEP   , 0, 0 }
			};
			int aWidths[] = { 300, 340, 380, 420 };
			LPCREATESTRUCT lpcs = (LPCREATESTRUCT)lParam;
			RECT           rect;
			LOGFONT        lf;
			UINT           uStat;

			GetClientRect( hWnd, &rect );

			ac->hInst		= lpcs->hInstance;
			ac->hWndMain	= hWnd;

			ac->hWndTool = CreateToolbarEx( ac->hWndMain
										  , WS_CHILD | WS_VISIBLE | TBSTYLE_TOOLTIPS
										  , IDC_TOOLBAR
										  , 9
										  , ac->hInst
										  , (UINT)MAKEINTRESOURCE(IDB_TOOLBAR)
										  , tbTool
										  , sizeof(tbTool) / sizeof(TBBUTTON)
										  , 16
										  , 17
										  , 0
										  , 0
										  , sizeof(TBBUTTON)
										  );

			ac->clrBgEdit = VsGetProfileInt( "Local\\VisualSpice\\COLOR", "EDITBG", RGB(255,255,255) );
			ac->clrFgEdit = VsGetProfileInt( "Local\\VisualSpice\\COLOR", "EDITFG", RGB(  0,  0,  0) );
			ac->hBrBgEdit = CreateSolidBrush( ac->clrBgEdit );
			ac->hWndEdit  = CreateEditView( ac );
			if ( VsGetProfileFont("Fonts\\VisualSpice","EDIT",&lf) ) {
				ac->hFontEdit = CreateFontIndirect( &lf );
			} else {
				ac->hFontEdit = GetStockObject( SYSTEM_FIXED_FONT );
			}
			SendMessage( ac->hWndEdit, WM_SETFONT, (WPARAM)ac->hFontEdit, (LPARAM)MAKELPARAM(TRUE,0) );

			ac->clrBgOutput = VsGetProfileInt( "Local\\VisualSpice\\COLOR", "OUTBG", RGB(255,255,255) );
			ac->clrFgOutput = VsGetProfileInt( "Local\\VisualSpice\\COLOR", "OUTFG", RGB(  0,  0,  0) );
			ac->hBrBgOutput = CreateSolidBrush( ac->clrBgOutput );
			ac->hWndOutput  = CreateOutput( ac );
			if ( VsGetProfileFont("Fonts\\VisualSpice","OUT",&lf) ) {
				ac->hFontOutput = CreateFontIndirect( &lf );
			} else {
				ac->hFontOutput = GetStockObject( SYSTEM_FIXED_FONT );
			}
			SendMessage( ac->hWndOutput, WM_SETFONT, (WPARAM)ac->hFontOutput, (LPARAM)MAKELPARAM(FALSE,0) );

			ac->hWndSplitter = CreateSplitter( ac->hWndMain
											 , FALSE
											 , IDC_SPLITTER
											 , LoadCursor( ac->hInst, MAKEINTRESOURCE(IDC_HSPLITTER) )
											 , ac->hInst
											 , rect.bottom / 4 * 3
											 );

			ac->hWndStat = CreateStatusWindow( WS_CHILD | WS_VISIBLE | SBS_SIZEGRIP
											 , NULL
											 , ac->hWndMain
											 , IDC_STATBAR
											 );
			SendMessage( ac->hWndStat, SB_SETPARTS, sizeof(aWidths) / sizeof(int), (LPARAM)aWidths );
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"VisualSpice READY." );
			UpdateKeyStatus( ac->hWndStat );

			uStat = VsGetProfileInt( "Local\\VisualSpice\\VIEW", "TOOLBAR", MF_CHECKED );
			if ( uStat & MF_CHECKED ) {
				CheckMenuItem( GetMenu(ac->hWndMain), ID_VIEW_TOOLBAR, MF_CHECKED );
				ShowWindow( ac->hWndTool, SW_SHOW );
			} else {
				CheckMenuItem( GetMenu(ac->hWndMain), ID_VIEW_TOOLBAR, MF_UNCHECKED );
				ShowWindow( ac->hWndTool, SW_HIDE );
			}

			uStat = VsGetProfileInt( "Local\\VisualSpice\\VIEW", "STATUSBAR", MF_CHECKED );
			if ( uStat & MF_CHECKED ) {
				CheckMenuItem( GetMenu(ac->hWndMain), ID_VIEW_STATUS_BAR, MF_CHECKED );
				ShowWindow( ac->hWndStat, SW_SHOW );
			} else {
				CheckMenuItem( GetMenu(ac->hWndMain), ID_VIEW_STATUS_BAR, MF_UNCHECKED );
				ShowWindow( ac->hWndStat, SW_HIDE );
			}

			// tH_IvV̓ǂݍ
			lstrcpy( ac->szSpicePath  , VsGetProfileString("Exec"  , "SMC"        , "C:\\SPICE\\SMC.EXE" ) );
			lstrcpy( ac->szIncludePath, VsGetProfileString("Folder", "SMI"        , "C:\\SPICE\\SMI"     ) );
			lstrcpy( ac->szSpiceHelp  , VsGetProfileString("HTML"  , "SPICE"      , "C:\\SPICE\\DOC\\HTM") );
			lstrcpy( ac->szVSpiceHelp , VsGetProfileString("HTML"  , "VisualSpice", "C:\\SPICE\\DOC\\HTM") );

			// rhݒ̓ǂݍ
			ac->bClock = VsGetProfileInt( "Local\\VisualSpice\\SMC", "CLOCK"    , TRUE  );
			ac->bCheck = VsGetProfileInt( "Local\\VisualSpice\\SMC", "CHECK"    , TRUE  );
			ac->bLoop  = VsGetProfileInt( "Local\\VisualSpice\\SMC", "LOOP"     , FALSE );
			ac->bFade  = VsGetProfileInt( "Local\\VisualSpice\\SMC", "FADE"     , FALSE );
			ac->nLoop  = VsGetProfileInt( "Local\\VisualSpice\\SMC", "LOOPCOUNT", 2     );
			ac->nFade  = VsGetProfileInt( "Local\\VisualSpice\\SMC", "FADESPEED", 256   );

			// R}hCŃt@Cw肳ꂽꍇ̏
			if ( lstrlen(lpcs->lpCreateParams) ) {
				// ̃t@Cw肳ƃ__ȃoOB
				SetFileName( ac, lpcs->lpCreateParams );
				LoadSmc( ac );
			} else {
				lstrcpy( ac->szFileName, "̖ݒ" );
				lstrcpy( ac->szMidiName, "̖ݒ" );
			}
			SetTitle( ac, FALSE );

			// ̑̏
			{
				LPCTSTR lpszFind;

				lpszFind = VsGetProfileString( "Local\\VisualSpice\\FINDHIST", "0", NULL );
				if ( lpszFind ) {
					ac->lpszFind = strdup( lpszFind );
				} else {
					ac->lpszFind = NULL;
				}
			}

			SetFocus( ac->hWndEdit );
		}
		break;

	case WM_DESTROY:
		CloseMIDI( ac );
		PostQuitMessage( 0 );
		break;

	case WM_MENUSELECT:
		{
			wsprintf( ac->szMessage, "%X\n", wParam );
			OutputDebugString( ac->szMessage );
		}
		if ( HIWORD(wParam) == 0xFFFF || HIWORD(wParam) & MF_SEPARATOR ) {
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"VisualSpice READY." );
			break;
		}

		switch ( LOWORD(wParam) ) {
		default:
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"VisualSpice READY." );
			break;

		case ID_APP_EXIT:			// t@C-VisualSpicȅI
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"VisualSpiceI܂" );
			break;

		case ID_FILE_NEW:			// t@C-VK쐬
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"VKSMCt@C쐬܂" );
			break;

		case ID_FILE_OPEN:			// t@C-J
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"SMCt@Cǂݍ݂܂" );
			break;

		case ID_FILE_SAVE_AS:		// t@C-Otĕۑ
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"ҏWSMCt@Ct@Cw肵ĕۑ܂" );
			break;

		case ID_FILE_SAVE:			// t@C-㏑ۑ
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"ҏWSMCt@C㏑ۑ܂" );
			break;

		case ID_FILE_PRINT_SETUP:	// t@C-v^ݒ
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"v^Ɋւݒs܂" );
			break;

		case ID_FILE_PRINT:			// t@C-
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"ҏWSMCt@C܂" );
			break;

		case ID_EDIT_UNDO:			// ҏW-Ƃɖ߂
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"SMCt@C̕ҏWePȌԂɖ߂܂" );
			break;

		case ID_EDIT_CUT:			// ҏW-Jbg
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"Iꂽ͈͂̕؂Nbv{[hɓ]܂" );
			break;

		case ID_EDIT_COPY:			// ҏW-Rs[
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"Iꂽ͈͂̕Nbv{[hɕʂ܂" );
			break;

		case ID_EDIT_PASTE:			// ҏW-\t
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"Nbv{[h̓e(eLXg)Lbg̈ʒuɑ}܂" );
			break;

		case ID_EDIT_DELETE:		// ҏW-폜
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"Iꂽ͈͂̕폜܂" );
			break;

		case ID_EDIT_FIND:			// ҏW-
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"w肵Č܂" );
			break;

		case ID_EDIT_NEXT:			// ҏW-
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"\ߎw肳ꂽ̎̈ʒu܂" );
			break;

		case ID_EDIT_REPLACE:		// ҏW-u
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"w̕ɒu܂" );
			break;

		case ID_EDIT_GOTO:			// ҏW-wsɃWv
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"wsɃWv܂" );
			break;

		case ID_VIEW_TOOLBAR:		// \-c[o[
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"c[o[̕\^\؂ւ܂" );
			break;

		case ID_VIEW_STATUS_BAR:	// \-Xe[^Xo[
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"Xe[^Xo[̕\^\؂ւ܂" );
			break;

		case ID_BUILD_COMPILE:		// rh-RpC
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"ҏWSMCt@CX^_[hMIDIt@Cɕϊ܂" );
			break;

		case ID_BUILD_PLAY:			// rh-t
			wsprintf( ac->szMessage,"%sAv[[gĉt܂", ac->szMidiName );
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)ac->szMessage );
			break;

		case ID_BUILD_PLAY_EXT:		// rh-Ov[ŉt
			wsprintf( ac->szMessage,"%sX^_[hMIDIt@CɊ֘AtꂽAvP[Vgĉt܂", ac->szMidiName );
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)ac->szMessage );
			break;

		case ID_BUILD_STOP:			// rh-t~
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"v[[ɂX^_[hMIDIt@C̉t~܂" );
			break;

		case ID_BUILD_SETUP:		// rh-ݒ
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"RpCIvV̐ݒs܂" );
			break;

		case ID_OPT_DIR:			// IvV-tH_
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"vOet@C̈ʒuw肵܂" );
			break;

		case ID_OPT_FONT_EDIT:			// IvV-tHg
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"SMCt@CҏWEBhẼtHgw肵܂" );
			break;

		case ID_OPT_EDITBG:			// IvV-F
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"SMCt@CҏWEBhE̔wiFw肵܂" );
			break;

		case ID_OPT_EDITFG:			// IvV-F
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"SMCt@CҏWEBhE̐̕Fw肵܂" );
			break;

		case ID_OPT_OUTBG:			// IvV-F
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"AEgvbgEBhE̔wiFw肵܂" );
			break;

		case ID_OPT_OUTFG:			// IvV-F
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"AEgvbgEBhE̐̕Fw肵܂" );
			break;

		case ID_OPT_FONT_OUT:			// IvV-tHg
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"AEgvbgEBhẼtHgw肵܂" );
			break;

		case ID_HELP_SPICE:			// XpCX̃wv
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"SPICEVXẽwvt@C(HTML`)\܂" );
			break;

		case ID_APP_ABOUT:			// o[W
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"VisualSpicẽo[W\܂" );
			break;
		}
		break;

	case WM_NOTIFY:
		if ( ((LPNMHDR)lParam)->code == TTN_POP ) {
			SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"VisualSpice READY." );
			return 0;
		}

		if ( ((LPNMHDR)lParam)->code == TTN_NEEDTEXT ) {
			LPTOOLTIPTEXT lpttt;

			lpttt = (LPTOOLTIPTEXT)lParam;
			lpttt->hinst = ac->hInst;

			switch ( lpttt->hdr.idFrom ) {
			case ID_FILE_NEW:
				lpttt->lpszText = "VK쐬";
				SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"VKSMCt@C쐬" );
				break;

			case ID_FILE_OPEN:
				lpttt->lpszText = "J";
				SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"SMCt@CJ" );
				break;

			case ID_FILE_SAVE:
				SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"ҏWSMCt@C㏑ۑ" );
				lpttt->lpszText = "㏑ۑ";
				break;

			case ID_EDIT_CUT:
				SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"I͈͂؂Nbv{[hɓ]" );
				lpttt->lpszText = "؂";
				break;

			case ID_EDIT_COPY:
				SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"I͈͂𕡎ʂăNbv{[hɓ]" );
				lpttt->lpszText = "Rs[";
				break;

			case ID_EDIT_PASTE:
				SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"Nbv{[h̓eLbg̈ʒuɕ" );
				lpttt->lpszText = "\t";
				break;

			case ID_EDIT_UNDO:
				SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"O̕ύXɖ߂" );
				lpttt->lpszText = "ɖ߂";
				break;

			case ID_EDIT_FIND:
				SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"镶w肵Č" );
				lpttt->lpszText = "";
				break;

			case ID_EDIT_NEXT:
				SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"w肳Ă镶" );
				lpttt->lpszText = "";
				break;

			case ID_BUILD_COMPILE:
				SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"SMCt@CX^_[hMIDIt@Cɕϊ" );
				lpttt->lpszText = "RpC";
				break;

			case ID_BUILD_PLAY:
				SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"X^_[hMIDIt@CɕϊꂽSMCt@Ct(v[[)" );
				lpttt->lpszText = "t";
				break;

			case ID_BUILD_STOP:
				SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"X^_[hMIDIt@C̉t~" );
				lpttt->lpszText = "t~";
				break;

			default:
				lpttt->lpszText = "Ł`";
				SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"ԂoO" );
				break;
			}
		}
		break;

	case WM_SYSCOMMAND:
		if ( wParam == SC_CLOSE && ExitCheck(ac) == FALSE ) {
			break;
		}
		return DefWindowProc( hWnd, uMsg, wParam, lParam );

	case WM_COMMAND:
		// GfBbgEBhE̓eXVꂽH
		if ( HIWORD(wParam) == EN_CHANGE && LOWORD(wParam) == IDC_MAINEDIT ) {
			if ( !ac->bModify ) {
				ac->bModify = TRUE;
				SetTitle( ac, ac->bModify );
			}
			return 0;
		}

		// j[nhO
		switch ( LOWORD(wParam) ) {

		case ID_APP_EXIT:			// t@C-VisualSpicȅI
			if ( ExitCheck(ac) ) {
				DestroyWindow( ac->hWndMain );
			}
			break;

		case ID_FILE_NEW:			// t@C-VK쐬
			if ( ExitCheck(ac) ) {
				CloseMIDI( ac );
				EnableMenuItem( GetMenu(ac->hWndMain), ID_BUILD_PLAY, MF_ENABLED );
				EnableMenuItem( GetMenu(ac->hWndMain), ID_BUILD_STOP, MF_GRAYED  );
				lstrcpy( ac->szFileName, "̖ݒ" );
				lstrcpy( ac->szMidiName, "̖ݒ" );
				SetTitle( ac, FALSE );
				NewSMC( ac );
			}
			break;

		case ID_FILE_OPEN:			// t@C-J
			if ( ExitCheck(ac) ) {
				OnFileOpen( ac );
			}
			break;

		case ID_FILE_SAVE_AS:		// t@C-Otĕۑ
			OnFileSaveAs( ac );
			SetTitle( ac, ac->bModify );
			break;

		case ID_FILE_SAVE:			// t@C-㏑ۑ
			if ( lstrcmp(ac->szFileName, "̖ݒ") ) {
				SaveSmc( ac );
				SetTitle( ac, ac->bModify );
			} else {
				OnFileSaveAs( ac );
			}
			break;

		case ID_FILE_PRINT_SETUP:
			{
				PRINTDLG pd;

				ZeroMemory( &pd, sizeof(PRINTDLG) );
				pd.lStructSize = sizeof(PRINTDLG);
				pd.hwndOwner   = ac->hWndMain;
				pd.Flags       = PD_PRINTSETUP;

				PrintDlg( &pd );
			}
			break;

		case ID_FILE_PRINT:
			{
				PRINTDLG  pd;

				ZeroMemory( &pd, sizeof(PRINTDLG) );
				pd.lStructSize = sizeof(PRINTDLG);
				pd.hwndOwner   = ac->hWndMain;
				pd.Flags       = PD_RETURNDC | PD_HIDEPRINTTOFILE | PD_USEDEVMODECOPIES;

				if ( PrintDlg(&pd) ) {
					DOCINFO  di;

					di.lpszDocName = strrchr( ac->szFileName, '\\' );
					if ( di.lpszDocName == NULL ) {
						di.lpszDocName = ac->szFileName;
					} else {
						di.lpszDocName++;
					}
					wsprintf( ac->szMessage, "VisualSpice - %s", di.lpszDocName );
					di.cbSize      = sizeof(DOCINFO);
					di.lpszDocName = ac->szMessage;
					di.lpszOutput  = NULL;
					StartDoc( pd.hDC, &di );
					{
						DWORD    dwWidth;
						DWORD    dwHeight;
						BOOL     bRes;
						int      nPage = 0;
						long     lTextSize;
						LPTSTR   lpszSmc;


						lTextSize = GetWindowTextLength( ac->hWndEdit );
						lpszSmc = (LPTSTR)calloc( lTextSize + 1, sizeof(TCHAR) );
						if ( lpszSmc ) {
							GetWindowText( ac->hWndEdit, lpszSmc, lTextSize + 1 );

							dwWidth  = GetDeviceCaps( pd.hDC, PHYSICALWIDTH  ) - (GetDeviceCaps(pd.hDC,PHYSICALOFFSETX) * 2);
							dwHeight = GetDeviceCaps( pd.hDC, PHYSICALHEIGHT ) - (GetDeviceCaps(pd.hDC,PHYSICALOFFSETY) * 2);

							bRes = DrawPage( ac,pd.hDC, dwWidth, dwHeight, ++nPage, lpszSmc );
							while ( bRes ) {
								bRes = DrawPage( ac,pd.hDC, dwWidth, dwHeight, ++nPage, NULL );
							}
							free( lpszSmc );
						}
					}
					EndDoc( pd.hDC );
					DeleteDC( pd.hDC );
					if ( pd.hDevMode ) {
						GlobalFree( pd.hDevMode );
					}
					if ( pd.hDevNames ) {
						GlobalFree( pd.hDevNames );
					}
				}
				SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)"VisualSpice READY." );
			}
			break;

		case ID_EDIT_UNDO:			// ҏW-Ƃɖ߂
			SendMessage( ac->hWndEdit, EM_UNDO, 0, 0 );
			break;

		case ID_EDIT_CUT:			// ҏW-Jbg
			SendMessage( ac->hWndEdit, WM_CUT, 0, 0 );
			break;

		case ID_EDIT_COPY:			// ҏW-Rs[
			SendMessage( ac->hWndEdit, WM_COPY, 0, 0 );
			break;

		case ID_EDIT_PASTE:			// ҏW-\t
			SendMessage( ac->hWndEdit, WM_PASTE, 0, 0 );
			break;

		case ID_EDIT_DELETE:		// ҏW-폜
			SendMessage( ac->hWndEdit, WM_CLEAR, 0, 0 );
			break;

		case ID_EDIT_FIND:			// ҏW-
			if ( Find(ac) != IDOK ) {
				break;
			}
			// continue to ID_EDIT_NEXT

		case ID_EDIT_NEXT:			// ҏW-
			if ( ac->lpszFind == NULL ) {
				SendMessage( ac->hWndMain, WM_COMMAND, (WPARAM)ID_EDIT_FIND, (LPARAM)hWnd );
				break;
			}
			DoFind( ac );
			break;

		case ID_EDIT_REPLACE:		// ҏW-u
			Replace( ac );
			break;

		case ID_EDIT_GOTO:			// ҏW-wsɃWv
			{
				int nLine;

				nLine = Goto( ac );
				if ( nLine > 0 ) {
					SendMessage( ac->hWndMain, WM_GOTOLINE, (WPARAM)--nLine, (LPARAM)ac->szFileName ); 
				}
			}
			break;

		case ID_VIEW_TOOLBAR:		// \-c[o[
			{
				UINT uStat;

				uStat = GetMenuState( GetMenu(ac->hWndMain), ID_VIEW_TOOLBAR, MF_BYCOMMAND );
				if ( uStat & MF_CHECKED ) {
					CheckMenuItem( GetMenu(ac->hWndMain), ID_VIEW_TOOLBAR, MF_UNCHECKED );
					ShowWindow( ac->hWndTool, SW_HIDE );
				} else {
					CheckMenuItem( GetMenu(ac->hWndMain), ID_VIEW_TOOLBAR, MF_CHECKED );
					ShowWindow( ac->hWndTool, SW_SHOW );
				}
				RecalcLayout( ac );

				uStat = GetMenuState( GetMenu(ac->hWndMain), ID_VIEW_TOOLBAR, MF_BYCOMMAND );
				VsPutProfileInt( "Local\\VisualSpice\\VIEW", "TOOLBAR", uStat );
			}
			break;

		case ID_VIEW_STATUS_BAR:	// \-Xe[^Xo[
			{
				UINT uStat;

				uStat = GetMenuState( GetMenu(ac->hWndMain), ID_VIEW_STATUS_BAR, MF_BYCOMMAND );
				if ( uStat & MF_CHECKED ) {
					CheckMenuItem( GetMenu(ac->hWndMain), ID_VIEW_STATUS_BAR, MF_UNCHECKED );
					ShowWindow( ac->hWndStat, SW_HIDE );
				} else {
					CheckMenuItem( GetMenu(ac->hWndMain), ID_VIEW_STATUS_BAR, MF_CHECKED );
					ShowWindow( ac->hWndStat, SW_SHOW );
				}
				RecalcLayout( ac );

				uStat = GetMenuState( GetMenu(ac->hWndMain), ID_VIEW_STATUS_BAR, MF_BYCOMMAND );
				VsPutProfileInt( "Local\\VisualSpice\\VIEW", "STATUSBAR", uStat );
			}
			break;

		case ID_BUILD_COMPILE:		// rh-RpC
			SendMessage( ac->hWndMain, WM_COMMAND, (WPARAM)ID_BUILD_STOP, (LPARAM)hWnd );
			if ( ac->bModify ) {
				SendMessage( ac->hWndMain, WM_COMMAND, (WPARAM)ID_FILE_SAVE, (LPARAM)hWnd );
			}
			EnableWindow( ac->hWndTool, FALSE );
			UpdateWindow( hWnd );
			Compile( ac );
			EnableWindow( ac->hWndTool, TRUE );
			break;

		case ID_BUILD_PLAY:			// rh-t
			if ( ac->bModify ) {
				wsprintf( ac->szMessage, "%s̓RpCĂ܂B\nRpC܂H", ac->szFileName );
				if ( MessageBox( ac->hWndMain, ac->szMessage, "VisualSpice - t", MB_ICONQUESTION | MB_YESNO ) == IDYES ) {
					SendMessage( ac->hWndMain, WM_COMMAND, (WPARAM)ID_BUILD_COMPILE, (LPARAM)hWnd );
				}
			}
			if ( PlayMIDI(ac) ) {
				EnableMenuItem( GetMenu(ac->hWndMain), ID_BUILD_PLAY, MF_GRAYED  );
				EnableMenuItem( GetMenu(ac->hWndMain), ID_BUILD_STOP, MF_ENABLED );
				EnableToolButton( ac->hWndTool, ID_BUILD_PLAY, FALSE );
				EnableToolButton( ac->hWndTool, ID_BUILD_STOP, TRUE  );
			}			
			break;

		case ID_BUILD_PLAY_EXT:		// rh-Ov[ŉt
			if ( ac->bModify ) {
				SendMessage( ac->hWndMain, WM_COMMAND, (WPARAM)ID_BUILD_COMPILE, (LPARAM)hWnd );
			}
			CloseMIDI( ac );
			if ( (int)ShellExecute(hWnd, "play", ac->szMidiName, NULL, ".", SW_SHOW) < 32 ) {
				MessageBox( hWnd, "Ov[[ł̉t͂ł܂B", "VisualSpice - rh-Ov[ŉt", MB_OK );
			}
			SetFocus( ac->hWndEdit );
			break;

		case ID_BUILD_STOP:			// rh-t~
			EnableMenuItem( GetMenu(ac->hWndMain), ID_BUILD_PLAY, MF_ENABLED  );
			EnableMenuItem( GetMenu(ac->hWndMain), ID_BUILD_STOP, MF_GRAYED   );
			EnableToolButton( ac->hWndTool, ID_BUILD_PLAY, TRUE  );
			EnableToolButton( ac->hWndTool, ID_BUILD_STOP, FALSE );
			CloseMIDI( ac );
			break;

		case ID_BUILD_SETUP:		// rh-ݒ
			CompileOption( ac );
			break;

		case ID_OPT_DIR:			// IvV-tH_
			FolderOption( ac );
			break;

		case ID_OPT_EDITFG:
			if ( SelectColor(ac,&ac->clrFgEdit) ) {
				SendMessage( ac->hWndEdit, WM_SETFONT, (WPARAM)ac->hFontEdit, (LPARAM)MAKELPARAM(TRUE,0) );
				VsPutProfileInt( "Local\\VisualSpice\\COLOR", "EDITFG", ac->clrFgEdit );
			}
			break;

		case ID_OPT_EDITBG:
			if ( SelectColor(ac,&ac->clrBgEdit) ) {
				DeleteObject( ac->hBrBgEdit );
				ac->hBrBgEdit = CreateSolidBrush( ac->clrBgEdit );
				SendMessage( ac->hWndEdit, WM_SETFONT, (WPARAM)ac->hFontEdit, (LPARAM)MAKELPARAM(TRUE,0) );
				VsPutProfileInt( "Local\\VisualSpice\\COLOR", "EDITBG", ac->clrBgEdit );
			}
			break;

		case ID_OPT_OUTFG:
			if ( SelectColor(ac,&ac->clrFgOutput) ) {
				SendMessage( ac->hWndOutput, WM_SETFONT, (WPARAM)ac->hFontOutput, (LPARAM)MAKELPARAM(TRUE,0) );
				VsPutProfileInt( "Local\\VisualSpice\\COLOR", "OUTFG", ac->clrFgOutput );
			}
			break;

		case ID_OPT_OUTBG:
			if ( SelectColor(ac,&ac->clrBgOutput) ) {
				DeleteObject( ac->hBrBgOutput );
				ac->hBrBgOutput = CreateSolidBrush( ac->clrBgOutput );
				SendMessage( ac->hWndOutput, WM_SETFONT, (WPARAM)ac->hFontOutput, (LPARAM)MAKELPARAM(TRUE,0) );
				VsPutProfileInt( "Local\\VisualSpice\\COLOR", "OUTBG", ac->clrBgOutput );
			}
			break;

		case ID_OPT_FONT_EDIT:			// IvV-tHg
			{
				CHOOSEFONT cf;
				LOGFONT    lf;

				GetObject( ac->hFontEdit, sizeof(LOGFONT), &lf );

				cf.lStructSize = sizeof(CHOOSEFONT);
				cf.hwndOwner   = ac->hWndMain;
				cf.lpLogFont   = &lf;
				cf.Flags       = CF_FORCEFONTEXIST | CF_INITTOLOGFONTSTRUCT | CF_SCREENFONTS;
					
				if ( ChooseFont(&cf) ) {
					// ̂̃p[^́AI...
					lf.lfWidth         = 0;
					lf.lfEscapement    = 0;
					lf.lfOrientation   = 0;
					lf.lfUnderline     = 0;
					lf.lfStrikeOut     = 0;
					lf.lfClipPrecision = CLIP_STROKE_PRECIS;
					lf.lfQuality       = DRAFT_QUALITY;

					DeleteObject( ac->hFontEdit );
					ac->hFontEdit = CreateFontIndirect( &lf );
					VsPutProfileFont( "Fonts\\VisualSpice", "EDIT", &lf );
					SendMessage( ac->hWndEdit, WM_SETFONT, (WPARAM)ac->hFontEdit, (LPARAM)MAKELPARAM(TRUE,0) );
				}
			}
			break;

		case ID_OPT_FONT_OUT:			// IvV-tHg
			{
				CHOOSEFONT cf;
				LOGFONT    lf;

				GetObject( ac->hFontOutput, sizeof(LOGFONT), &lf );

				cf.lStructSize = sizeof(CHOOSEFONT);
				cf.hwndOwner   = ac->hWndMain;
				cf.lpLogFont   = &lf;
				cf.Flags       = CF_FORCEFONTEXIST | CF_INITTOLOGFONTSTRUCT | CF_SCREENFONTS;
					
				if ( ChooseFont(&cf) ) {
					// ̂̃p[^́AI...
					lf.lfWidth         = 0;
					lf.lfEscapement    = 0;
					lf.lfOrientation   = 0;
					lf.lfUnderline     = 0;
					lf.lfStrikeOut     = 0;
					lf.lfClipPrecision = CLIP_STROKE_PRECIS;
					lf.lfQuality       = DRAFT_QUALITY;

					DeleteObject( ac->hFontOutput );
					ac->hFontOutput = CreateFontIndirect( &lf );
					VsPutProfileFont( "Fonts\\VisualSpice", "OUT", &lf );
					SendMessage( ac->hWndOutput, WM_SETFONT, (WPARAM)ac->hFontOutput, (LPARAM)MAKELPARAM(TRUE,0) );
				}
			}
			break;

		case ID_HELP_SPICE:			// XpCX̃wv
			ShellExecute( hWnd, "open", ac->szSpiceHelp, NULL, NULL, SW_SHOW );
			break;

		case ID_APP_ABOUT:			// o[W
			About( ac );
			break;
        }
		SetFocus( ac->hWndEdit );
		break;

	// AEgvbgEChEŁAG[s|[g_uNbÑbZ[W
	case WM_GOTOLINE:
		{
			WPARAM wIdx;

			if ( strcmp(ac->szFileName,(LPCSTR)lParam) ) {
				MessageBox( hWnd, "Ot@Cւ̃Wv͂ł܂B", "VisualSpice - wsɃWv", MB_OK );
				break;
			}
			wIdx = SendMessage( ac->hWndEdit, EM_LINEINDEX, (WPARAM)wParam, 0 );
			SendMessage( ac->hWndEdit, EM_SETSEL     , wIdx, (LPARAM)wIdx );
			SendMessage( ac->hWndEdit, EM_SCROLLCARET,    0,            0 );
			SetFocus( ac->hWndEdit );
		}
		break;

	case WM_SIZE:
		SendMessage( ac->hWndTool    , uMsg, wParam, lParam );
		SendMessage( ac->hWndStat    , uMsg, wParam, lParam );
		SendMessage( ac->hWndSplitter, uMsg, wParam, lParam );
		RecalcLayout( ac );
		RecalcStatLayout( ac->hWndStat );
		SetFocus( ac->hWndEdit );
		break;

	// tIbZ[W
	case MM_MCINOTIFY:
		EnableMenuItem( GetMenu(ac->hWndMain), ID_BUILD_PLAY, MF_ENABLED );
		EnableMenuItem( GetMenu(ac->hWndMain), ID_BUILD_STOP, MF_GRAYED  );
		EnableToolButton( ac->hWndTool, ID_BUILD_PLAY, TRUE  );
		EnableToolButton( ac->hWndTool, ID_BUILD_STOP, FALSE );
		CloseMIDI( ac );
		break;

	case WM_CTLCOLOREDIT:
		if ( (HWND)lParam == ac->hWndEdit ) {
			SetTextColor( (HDC)wParam, ac->clrFgEdit ); 
			SetBkColor(   (HDC)wParam, ac->clrBgEdit );
			UpdateMenu( ac );
			return (int)ac->hBrBgEdit;
		} else if ( (HWND)lParam == ac->hWndOutput ) {
			SetTextColor( (HDC)wParam, ac->clrFgOutput ); 
			SetBkColor(   (HDC)wParam, ac->clrBgOutput );
			return (int)ac->hBrBgOutput;
		}
		return DefWindowProc( hWnd, uMsg, wParam, lParam );

	// j[J̏
	case WM_ENTERMENULOOP:
		UpdateMenu( ac );
		break;

	case WM_KEYDOWN:
		switch ( wParam ) {
		case VK_CAPITAL:
		case VK_KANA:
		case VK_NUMLOCK:
			UpdateKeyStatus( ac->hWndStat );
			break;
		}
		break;

	default:
		return DefWindowProc( hWnd, uMsg, wParam, lParam );
	}
	return 0;
}


int WINAPI WinMain( HINSTANCE hInst, HINSTANCE hPrev, LPSTR lpszParm, int nCmdShow )
{
	static LPCSTR lpszClassName = "VSPICE";
	static LPCSTR lpszTitle     = "Visual Spice";
	       HACCEL hAccTable;
		   HWND   hMainWnd;
		   MSG    msg;


	if ( ExclusiveWindow( lpszClassName, lpszTitle ) ) {
		return 0;
	}
	InitCommonControls();
//	LoadLibrary( "Riched32.dll" );
	
	if ( !hPrev ) {
		WNDCLASS wcThisApp;

		wcThisApp.style         = 0;//CS_HREDRAW | CS_VREDRAW;
		wcThisApp.lpfnWndProc   = MainWndProc;
		wcThisApp.cbClsExtra    = 0;
		wcThisApp.cbWndExtra    = 0;
		wcThisApp.hInstance     = hInst;
		wcThisApp.hIcon         = LoadIcon( hInst, MAKEINTRESOURCE(IDI_VISUALSPICE) );
		wcThisApp.hCursor       = LoadCursor( NULL, IDC_ARROW );
		wcThisApp.hbrBackground = NULL;
		wcThisApp.lpszMenuName  = MAKEINTRESOURCE(IDR_MAINMENU);
		wcThisApp.lpszClassName = lpszClassName;

		RegisterClass( &wcThisApp );
	}
	hAccTable = LoadAccelerators( hInst, MAKEINTRESOURCE(IDR_ACCELERATOR) );

	hMainWnd = CreateWindow(  lpszClassName
							, lpszTitle
							, WS_OVERLAPPEDWINDOW
							, CW_USEDEFAULT
							, CW_USEDEFAULT
							, CW_USEDEFAULT
							, CW_USEDEFAULT
							, NULL
							, NULL
							, hInst
							, lpszParm
							);

	ShowWindow( hMainWnd, nCmdShow );
	UpdateWindow( hMainWnd );

	while ( GetMessage(&msg, NULL, 0, 0) ) {
		if ( TranslateAccelerator(hMainWnd,hAccTable,&msg) == FALSE ) {
//			if ( IsDialogMessage(hMainWnd, &msg) == FALSE ) {
				TranslateMessage( &msg );
				DispatchMessage( &msg );
//			}
		} else {
			DispatchMessage( &msg );
		}
	}

	return msg.wParam;
}
