#include <stdio.h>
#include <string.h>
#include <mbctype.h>

#include <windows.h>
#include <commctrl.h>

#include "main.h"
#include "resource.h"



void OutputSMC( AC *ac, BYTE *lpszStr )
{
	while ( *lpszStr != '\0' ) {
		if ( _ismbblead(*lpszStr) ) {
			WPARAM wCode;

			memcpy( &wCode, lpszStr, 2 );
			SendMessage( ac->hWndEdit, WM_CHAR, wCode, 1 );
			lpszStr++;
		} else if ( *lpszStr != '\r' ) {
			SendMessage( ac->hWndEdit, WM_CHAR, *lpszStr, 1 );
		}
		lpszStr++;
	}
}

void UpdateInstrument( AC *ac, HWND hDlg )
{
#if 0
	LPTSTR lpszBuf = NULL;	// first realloc same malloc.
	int    nBufLen = 0;
	int    nLen;
	int    nCount;
#endif
	int    nIdx;

	nIdx = SendDlgItemMessage( hDlg, IDC_INSTRUMENT, CB_GETCURSEL, 0, 0 );
	VsPutProfileInt( "Local\\VisualSpice\\INSTRUMENT", "CURRENT", nIdx );

#if 0
	nLen = GetDlgItemText( hDlg, IDC_INSTRUMENT, ac->szMessage, MSGBUF );
	if ( nLen ) {
		nIdx = SendDlgItemMessage( hDlg, IDC_INSTRUMENT, CB_FINDSTRING, (WPARAM)-1, (LPARAM)ac->szMessage );
		if ( nIdx == CB_ERR ) {
			nIdx = SendDlgItemMessage( hDlg, IDC_INSTRUMENT, CB_ADDSTRING, 0, (LPARAM)ac->szMessage );
		}
		if ( nIdx != CB_ERR ) {
			SendDlgItemMessage( hDlg, IDC_INSTRUMENT, CB_SETCURSEL, (WPARAM)nIdx, 0 );
		} else {
			SendDlgItemMessage( hDlg, IDC_INSTRUMENT, CB_SETCURSEL, 0, 0 );
		}
	}

	nCount = SendDlgItemMessage( hDlg, IDC_INSTRUMENT, CB_GETCOUNT, 0, 0 );
	for ( nIdx = 0; nIdx < nCount; nIdx++ ) {
		nLen = SendDlgItemMessage( hDlg, IDC_INSTRUMENT, CB_GETLBTEXTLEN, nIdx, 0 ) + 1;
		if ( nBufLen < nLen ) {
			nBufLen = nLen;
			lpszBuf = realloc( lpszBuf, nBufLen );
			if ( lpszBuf == NULL ) {
				VsPutProfileInt( "Local\\VisualSpice\\INSTRUMENT", "COUNT", 0 );
				return;
			}
		}
		SendDlgItemMessage( hDlg, IDC_INSTRUMENT, CB_GETLBTEXT, (WPARAM)nIdx, (LPARAM)lpszBuf );
		wsprintf( ac->szMessage, "%d", nIdx );
		VsPutProfileString( "Local\\VisualSpice\\INSTRUMENT", ac->szMessage, lpszBuf );
	}
	if ( lpszBuf ) {
		free( lpszBuf );
	}
	VsPutProfileInt( "Local\\VisualSpice\\INSTRUMENT", "COUNT", nCount );
#endif
}

int  RegisterInstrument( HWND hDlg, LPTSTR lpszInst )
{
	LPTSTR lpszSep;
	int    nIdx;
	int    nKind;

	lpszSep = strrchr( lpszInst, ',' );
	if ( lpszSep ) {
		*lpszSep = '\0';
		lpszSep++;
		nKind = atoi( lpszSep );
	} else {
		nKind = 0;
	}

	nIdx = SendDlgItemMessage( hDlg, IDC_INSTRUMENT, CB_ADDSTRING, 0, (LPARAM)lpszInst );
	if ( nIdx != CB_ERR ) {
		SendDlgItemMessage( hDlg, IDC_INSTRUMENT, CB_SETITEMDATA, (WPARAM)nIdx, (LPARAM)nKind );
	}

	return nIdx;
}

BOOL CALLBACK NewSmcDlgProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	static AC	*ac;
	static int   nOther;
	       BOOL  bEnable;
		   HWND  hCtl;


	switch ( uMsg ) {
	case WM_INITDIALOG:
		{
			int nCnt;
			int nCur;
			int nIdx;

			ac = (AC *)lParam;
			SendDlgItemMessage( hDlg, IDC_DVSNSPIN, UDM_SETRANGE, 0, MAKELPARAM(  80,  4) );
			SendDlgItemMessage( hDlg, IDC_DVSNSPIN, UDM_SETPOS  , 0, MAKELPARAM(   8,  0) );
			SendDlgItemMessage( hDlg, IDC_TMPOSPIN, UDM_SETRANGE, 0, MAKELPARAM(1024, 30) );

			SetDlgItemInt(  hDlg, IDC_DIVISION,  48, FALSE );
			SetDlgItemInt(  hDlg, IDC_TEMPO   , 120, FALSE );
			SetDlgItemText( hDlg, IDC_BEAT    , "4/4,48,8" );

			RegisterInstrument( hDlg, "GM,0"              );
			RegisterInstrument( hDlg, "Roland GS,1"       );
			RegisterInstrument( hDlg, "Roland SC-55,1"    );
			RegisterInstrument( hDlg, "Roland SC-88,1"    );
			RegisterInstrument( hDlg, "Roland SC-88Pro,1" );
			RegisterInstrument( hDlg, "YAMAHA XG,2"       );
			RegisterInstrument( hDlg, "YAMAHA MU50,2"     );
			RegisterInstrument( hDlg, "YAMAHA MU80,2"     );
			RegisterInstrument( hDlg, "YAMAHA MU90,2"     );

			nCnt = VsGetProfileInt( "Local\\VisualSpice\\INSTRUMENT", "COUNT", 0 );
			if ( nCnt ) {
				for ( nIdx = 0; nIdx < nCnt; nIdx++ ) {
					LPTSTR lpszInst;

					wsprintf( ac->szMessage, "%d", nIdx );
					lpszInst = (LPTSTR)VsGetProfileString( "Local\\VisualSpice\\INSTRUMENT", ac->szMessage, "" );
					RegisterInstrument( hDlg, lpszInst );
				}
			}
			nOther = RegisterInstrument( hDlg, "̑@@@,0" );
			SetDlgItemText( hDlg, IDC_OTHER, VsGetProfileString("Local\\VisualSpice\\INSTRUMENT","OTHER","̑̉") );

			nCur = VsGetProfileInt( "Local\\VisualSpice\\INSTRUMENT", "CURRENT", 0 );
			SendDlgItemMessage( hDlg, IDC_INSTRUMENT, CB_SETCURSEL, (WPARAM)nCur, 0 );
			if ( nCur == nOther ) {
				EnableWindow( GetDlgItem(hDlg,IDC_OTHER), TRUE );
			}
		}
		return TRUE;

	case WM_COMMAND:
		switch ( LOWORD(wParam) ) {
		case IDC_INSTRUMENT:
			if ( HIWORD(wParam) == CBN_SELCHANGE ) {
				if ( SendDlgItemMessage(hDlg,IDC_INSTRUMENT,CB_GETCURSEL,0,0) == nOther ) {
					EnableWindow(GetDlgItem(hDlg,IDC_OTHER),TRUE);
					SetFocus(GetDlgItem(hDlg,IDC_OTHER));
				} else {
					EnableWindow(GetDlgItem(hDlg,IDC_OTHER),FALSE);
				}
			}
			break;

		case IDC_DIVISION_F:
			bEnable = IsDlgButtonChecked( hDlg, IDC_DIVISION_F );
			hCtl    = GetDlgItem( hDlg, IDC_DIVISION );
			EnableWindow( hCtl, bEnable );
			if ( bEnable ) {
				SetFocus( hCtl );
			}
			break;

		case IDC_TEMPO_F:
			bEnable = IsDlgButtonChecked( hDlg, IDC_TEMPO_F );
			hCtl    = GetDlgItem( hDlg, IDC_TEMPO );
			EnableWindow( hCtl, bEnable );
			if ( bEnable ) {
				SetFocus( hCtl );
			}
			break;

		case IDC_BEAT_F:
			bEnable = IsDlgButtonChecked( hDlg, IDC_BEAT_F );
			hCtl    = GetDlgItem( hDlg, IDC_BEAT );
			EnableWindow( hCtl, bEnable );
			if ( bEnable ) {
				SetFocus( hCtl );
			}
			break;

		case IDOK:
			{
				LPTSTR	lpszBuf;
				LPCSTR  lpszTok;
				int      nLen;

				SetWindowText( ac->hWndEdit, "\r\n;---------------------------------------------------------------------------------------" );

				nLen = GetWindowTextLength( GetDlgItem(hDlg, IDC_COMMENT) );
				if ( nLen ) {
					nLen++;
					lpszBuf = malloc( nLen );
					if ( lpszBuf == NULL ) {
						OutputSMC( ac, ";Rgs\n" );
						EndDialog( hDlg, IDOK );
						return TRUE;
					}
					GetDlgItemText( hDlg, IDC_COMMENT, lpszBuf, nLen );

					lpszTok = strtok( lpszBuf, "\n" );
					OutputSMC( ac, ";---------------------------------------------------------------------------------------\n" );
					while ( lpszTok ) {
						wsprintf( ac->szMessage, "; %s\n", lpszTok );
						OutputSMC( ac, ac->szMessage );
						lpszTok = strtok( NULL, "\n" );
					}
					free( lpszBuf );
					OutputSMC( ac, ";---------------------------------------------------------------------------------------\n" );
				}

				OutputSMC( ac, "#include\t<smfstd.smi>\n#include\t<smf_gm.smi>\n" );
				nLen = SendDlgItemMessage( hDlg, IDC_INSTRUMENT, CB_GETCURSEL, 0, 0 );
				switch ( SendDlgItemMessage(hDlg,IDC_INSTRUMENT,CB_GETITEMDATA,(WPARAM)nLen,0) ) {
				case 1:
					OutputSMC( ac, "#include\t<rol_gs.smi>\n" );
					OutputSMC( ac, ";#include\t<yam_xg.smi>\n" );
					break;

				case 2:
					OutputSMC( ac, ";#include\t<rol_gs.smi>\n" );
					OutputSMC( ac, "#include\t<yam_xg.smi>\n" );
					break;

				default:
				case 0:
					OutputSMC( ac, ";#include\t<rol_gs.smi>\n" );
					OutputSMC( ac, ";#include\t<yam_xg.smi>\n" );
					break;
				}
				OutputSMC( ac, ";---------------------------------------------------------------------------------------\n" );

				nLen = 0;

				if ( GetDlgItemText(hDlg, IDC_MUSICNAME, ac->szMessage, MSGBUF - 2) > 0 ) {
					lstrcat( ac->szMessage, "\"\n" );
					OutputSMC( ac, "#music-name	\"" );
					OutputSMC( ac, ac->szMessage );
					nLen++;
				}

				if ( GetDlgItemText(hDlg, IDC_PROGRAMMER, ac->szMessage, MSGBUF - 2) > 0 ) {
					lstrcat( ac->szMessage, "\"\n" );
					OutputSMC( ac, "#programmer	\"" );
					OutputSMC( ac, ac->szMessage );
					OutputSMC( ac, "#copyright	\"Copyright (C) " );
					OutputSMC( ac, ac->szMessage );
					nLen++;
				}

				if ( SendDlgItemMessage(hDlg,IDC_INSTRUMENT,CB_GETCURSEL,0,0) == nOther ) {
					if ( GetDlgItemText(hDlg, IDC_OTHER, ac->szMessage, MSGBUF - 2) > 0 ) {
						VsPutProfileString( "Local\\VisualSpice\\INSTRUMENT", "OTHER", ac->szMessage );
						OutputSMC( ac, "#instrument	\"" );
						lstrcat( ac->szMessage, "\"\n" );
						OutputSMC( ac, ac->szMessage );
						nLen++;
					}
				} else {
					if ( GetDlgItemText(hDlg, IDC_INSTRUMENT, ac->szMessage, MSGBUF - 2) > 0 ) {
						OutputSMC( ac, "#instrument	\"" );
						lstrcat( ac->szMessage, "\"\n" );
						OutputSMC( ac, ac->szMessage );
						nLen++;
					}
				}

				if ( GetDlgItemText(hDlg, IDC_REM, ac->szMessage, MSGBUF - 2) > 0 ) {
					OutputSMC( ac, "#memo		\"" );
					lstrcat( ac->szMessage, "\"\n" );
					OutputSMC( ac, ac->szMessage );
					nLen++;
				}

				if ( nLen ) {
					OutputSMC( ac, ";---------------------------------------------------------------------------------------\n" );
				}

				nLen = 0;
				if ( IsDlgButtonChecked(hDlg, IDC_DIVISION_F) ) {
					wsprintf( ac->szMessage, "#division\t%d\n", GetDlgItemInt(hDlg, IDC_DIVISION, &bEnable, FALSE) );
					if ( bEnable ) {
						OutputSMC( ac, ac->szMessage );
					} else {
						OutputSMC( ac, "#division\t48\t; sɂftHglɐݒ\n" );
					}
					nLen++;
				}

				if ( IsDlgButtonChecked(hDlg, IDC_TEMPO_F) ) {
					wsprintf( ac->szMessage, "#tempo\t\t%d\n", GetDlgItemInt(hDlg, IDC_TEMPO, &bEnable, FALSE) );
					if ( bEnable ) {
						OutputSMC( ac, ac->szMessage );
					} else {
						OutputSMC( ac, "#tempo\t120\t; sɂftHglɐݒ\n" );
					}
					nLen++;
				}

				if ( IsDlgButtonChecked(hDlg, IDC_BEAT_F) ) {
					OutputSMC( ac, "#beat\t\t" );
					if ( GetDlgItemText(hDlg, IDC_BEAT, ac->szMessage, MSGBUF - 2) ) {
						lstrcat( ac->szMessage, "\n" );
						OutputSMC( ac, ac->szMessage );
					} else {
						OutputSMC( ac, "4/4,48,8	; sɂftHglɐݒ\n" );
					}
					nLen++;
				}

				if ( nLen ) {
					OutputSMC( ac, ";---------------------------------------------------------------------------------------\n" );
				}
			}
			UpdateInstrument( ac, hDlg );
			EndDialog( hDlg, IDOK );
			return TRUE;

		case IDCANCEL:
			UpdateInstrument( ac, hDlg );
			EndDialog( hDlg, IDCANCEL );
			return TRUE;
		}
		break;

		case WM_NOTIFY:
			if ( wParam == IDC_DVSNSPIN ) {
				NM_UPDOWN *lpnmud = (NM_UPDOWN *)lParam;

				lpnmud->iPos += lpnmud->iDelta;
				if ( lpnmud->iPos < 4 ) {
					lpnmud->iPos = 4;
				} else if ( lpnmud->iPos > 80 ) {
					lpnmud->iPos = 80;
				}
				SetDlgItemInt( hDlg, IDC_DIVISION, 6 * lpnmud->iPos, FALSE );
			}
			break;
	}
	return FALSE;
}

void NewSMC( AC *ac )
{
	DialogBoxParam( ac->hInst, MAKEINTRESOURCE(IDD_NEWSMC), ac->hWndMain, NewSmcDlgProc, (LPARAM)ac );
}
