#include <stdio.h>
#include <string.h>
#include <mbctype.h>

#include <windows.h>

#include "resource.h"
#include "main.h"


LRESULT CALLBACK OutputProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	WNDPROC	lpfnOrgProg = (WNDPROC)GetWindowLong( hWnd, GWL_USERDATA );
	LRESULT lRes;


	switch ( uMsg ) {
//	case WM_CHAR:
//		return 0;

	case WM_LBUTTONDBLCLK:
		lRes = CallWindowProc( lpfnOrgProg, hWnd, uMsg, wParam, lParam );
		{
			static BYTE  szLine[256];
			static BYTE  szFile[256];
			static BYTE  szError[256];
				   WORD  wLine;


			szLine[0] = 255;
			szLine[1] = 0;
			ZeroMemory( szFile , 256 );
			ZeroMemory( szError, 256 );

			wLine = (WORD)SendMessage( hWnd, EM_LINEFROMCHAR, (WPARAM)-1, 0 );
			SendMessage( hWnd, EM_GETLINE, (WPARAM)wLine, (LPARAM)szLine );

			sscanf( szLine, "%s %d:%s:", szFile, &wLine, szError );
			if ( memcmp(szError, "Error", 5) == 0 ) {
				SendMessage( GetParent(hWnd), WM_GOTOLINE, (WPARAM)--wLine, (LPARAM)szFile );
			}
		}
		return lRes;

	case WM_RBUTTONDOWN:
		break;

	default:
		return CallWindowProc( lpfnOrgProg, hWnd, uMsg, wParam, lParam );
	}
	return 0;
}

HWND CreateOutput( AC *ac )
{
	HWND	hWnd;
	WNDPROC	lpfnOrgProg;


	hWnd = CreateWindowEx( WS_EX_CLIENTEDGE
						 , "EDIT", ""
						 , WS_CHILD | WS_VISIBLE | WS_HSCROLL | WS_VSCROLL
						 | ES_AUTOHSCROLL | ES_LEFT// | ES_AUTOVSCROLL
						 | ES_MULTILINE// | ES_WANTRETURN | ES_READONLY
						 , 0, 0, CW_USEDEFAULT, CW_USEDEFAULT
						 , ac->hWndMain
						 , (HMENU)IDC_OUTPUT
						 , ac->hInst
						 , NULL
						 );

	lpfnOrgProg = (WNDPROC)GetWindowLong( hWnd, GWL_WNDPROC );
	SetWindowLong( hWnd, GWL_USERDATA, (LONG)lpfnOrgProg );
	SetWindowLong( hWnd, GWL_WNDPROC , (LONG)OutputProc );

	return hWnd;
}

void Output( AC *ac, BYTE *lpszStr )
{
	int nTail;

	nTail = GetWindowTextLength( ac->hWndOutput );
	SendMessage( ac->hWndOutput, EM_SETSEL    , (WPARAM)nTail, (LPARAM)nTail );
	SendMessage( ac->hWndOutput, EM_REPLACESEL, 0, (LPARAM)lpszStr );
}

void InitOutput( AC *ac )
{
	SetWindowText( ac->hWndOutput, NULL );
	UpdateWindow( ac->hWndOutput );
}