#include <windows.h>

#include "main.h"


void StopMIDI( AC *ac )
{
	MCI_GENERIC_PARMS	mciGen;


	if ( ac->mciOpen.wDeviceID == 0 ) {
		return;
	}

	mciSendCommand( ac->mciOpen.wDeviceID
				  , MCI_STOP
				  , MCI_WAIT
				  , (DWORD)(&mciGen)
				  );
}

void CloseMIDI( AC *ac )
{
	MCI_GENERIC_PARMS	mciGen;


	if ( ac->mciOpen.wDeviceID == 0 ) {
		return;
	}

	StopMIDI( ac );
	mciSendCommand( ac->mciOpen.wDeviceID
				  , MCI_CLOSE
				  , MCI_WAIT
				  , (DWORD)(&mciGen)
				  );
	ac->mciOpen.wDeviceID = 0;
}

BOOL PlayMIDI( AC *ac )
{
	MCIERROR		mciErr;
	MCI_SET_PARMS	mciSet;
	MCI_PLAY_PARMS	mciPlay;


	if ( ac->mciOpen.wDeviceID != 0 ) {
		CloseMIDI( ac );
	}
	ac->mciOpen.lpstrDeviceType = NULL;
	ac->mciOpen.lpstrElementName = ac->szMidiName;
	mciSet.dwTimeFormat = MCI_FORMAT_MILLISECONDS;
	mciPlay.dwCallback = (DWORD)ac->hWndMain;

	mciErr = mciSendCommand( 0, MCI_OPEN, MCI_WAIT | MCI_OPEN_ELEMENT, (DWORD)(&ac->mciOpen) );
	if ( mciErr != 0 ) {
		mciGetErrorString( mciErr, ac->szMessage, MSGBUF );
		MessageBox( ac->hWndMain, ac->szMessage, "VisualSpice - t", MB_OK );
		return FALSE;
	}
	mciSendCommand( ac->mciOpen.wDeviceID
				  , MCI_SET
				  , MCI_WAIT | MCI_SET_TIME_FORMAT
				  , (DWORD)(&mciSet)
				  );
	mciSendCommand( ac->mciOpen.wDeviceID
				  , MCI_SEEK
				  , MCI_WAIT | MCI_SEEK_TO_START
				  , 0
				  );
	mciErr = mciSendCommand( ac->mciOpen.wDeviceID
				  , MCI_PLAY
				  , MCI_NOTIFY
				  , (DWORD)(&mciPlay)
				  );
	if ( mciErr != 0 ) {
		mciGetErrorString( mciErr, ac->szMessage, MSGBUF );
		MessageBox( ac->hWndMain, ac->szMessage, "VisualSpice - t", MB_OK );
		return FALSE;
	}

	return TRUE;
}
