#include <stdio.h>
#include <string.h>
#include <mbctype.h>

#include <windows.h>
#include <commctrl.h>

#include "resource.h"
#include "main.h"

// A4cL͈(~[gx10) Canon LBP-450 LIPS4ł̎l
#define WA4SZ 2000
#define HA4SZ 2870

#define A4L 210
#define A4T 170
#define A4R (WA4SZ-A4L)
#define A4B (HA4SZ-A4T)
#define TTL 70
#define BDR 5

LPCSTR GetLine( LPSTR lpszText )
{
	static LPSTR lpszTail = "";
	       LPSTR lpszTop;

	if ( lpszText ) {
		lpszTop = lpszText;
	} else {
		lpszTop = lpszTail;
	}
	lpszTail = lpszTop;

	while ( *lpszTail ) {
		switch ( *lpszTail ) {
		case '\r':
			*lpszTail = '\0';
			lpszTail++;
		case '\n':
			*lpszTail = '\0';
			lpszTail++;
		case '\0':
			return lpszTop;

		default:
			lpszTail++;
		}
	}

	return NULL;
}


BOOL DrawLine( HDC hDC, HFONT hFontZen, HFONT hFontHan, int nY, LPCSTR lpszLine )
{
	LPCSTR lpszTop;
	int    nX;
	int    nLen;

	nX = A4L + BDR;
	while ( *lpszLine ) {
		lpszTop = lpszLine;
		if ( _ismbblead(*lpszLine) ) {
			do {
				lpszLine += 2;
			} while (  _ismbblead(*lpszLine) && *lpszLine );
			SelectObject( hDC, hFontZen );
		} else {
			do {
				lpszLine++;
			} while ( !_ismbblead(*lpszLine) && *lpszLine );
			SelectObject( hDC, hFontHan );
		}
		nLen = (int)(lpszLine - lpszTop);
		if ( nLen <= 0 ) {
			return FALSE;
		}
		nX += TabbedTextOut( hDC, nX, nY, lpszTop, nLen, 0, NULL, A4L + BDR );
	}

	return TRUE;
}

BOOL DrawPage( AC *ac, HDC hDC, DWORD dwWidth, DWORD dwHeight, int nPage, LPSTR lpszText )
{
	static int nLine = 0;
	RECT     rect;
	SIZE     size;
	HDC      hDcMem;
	HDC      hDcCrt;
	HDC      hDcPrn;
	HBITMAP  hBmpMem = NULL;
	HBITMAP  hBmpPrn = NULL;
	HPEN     hPen;
	HFONT    hFontHan;
	HFONT    hFontZen;
	HFONT    hFontTtl;
	HFONT    hFontVer;
	BOOL     bRes;
	LOGFONT  lf;
	int      nPos;
	LPSTR    lpszTitle;


	if ( lpszText ) {
		nLine = 0;
	}

	wsprintf( ac->szMessage, "%dy[W_O...", nPage );
	SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)ac->szMessage );

	hDcCrt  = GetDC( ac->hWndMain );
	hDcMem  = CreateCompatibleDC( hDcCrt );
	hDcPrn  = CreateCompatibleDC( hDC    );
	ReleaseDC( ac->hWndMain, hDcCrt );

	hBmpMem = CreateCompatibleBitmap( hDC, WA4SZ, HA4SZ );
	hBmpPrn = CreateCompatibleBitmap( hDC, WA4SZ, HA4SZ );
	SelectObject( hDcMem, hBmpMem );
	SelectObject( hDcPrn, hBmpPrn );

	SetBkMode( hDcMem, TRANSPARENT );

	rect.left   = 0;
	rect.top    = 0;
	rect.right  = WA4SZ;
	rect.bottom = HA4SZ;
	FillRect( hDcMem, &rect, (HBRUSH)GetStockObject(WHITE_BRUSH) );

	rect.left   = A4L;
	rect.top    = A4T;
	rect.right  = A4R;
	rect.bottom = (A4T + TTL);
	FillRect( hDcMem, &rect, (HBRUSH)GetStockObject(LTGRAY_BRUSH) );

	hPen = CreatePen( PS_SOLID, BDR, 0 );
	SelectObject( hDcMem, hPen );
	
	MoveToEx( hDcMem, A4L, A4T      , NULL );
	LineTo(   hDcMem, A4R, A4T             );
	MoveToEx( hDcMem, A4L, A4T + TTL, NULL );
	LineTo(   hDcMem, A4R, A4T + TTL       );
	MoveToEx( hDcMem, A4L, A4B      , NULL );
	LineTo(   hDcMem, A4R, A4B             );
	MoveToEx( hDcMem, A4L, A4T      , NULL );
	LineTo(   hDcMem, A4L, A4B             );
	MoveToEx( hDcMem, A4R, A4T      , NULL );
	LineTo(   hDcMem, A4R, A4B             );

	GetObject( ac->hFontEdit, sizeof(LOGFONT), &lf );
	lf.lfHeight  = 56;
	lf.lfCharSet = SHIFTJIS_CHARSET;
	lstrcpy( lf.lfFaceName, "lr oSVbN" );
	hFontTtl = CreateFontIndirect( &lf );
	
	lf.lfHeight = 28;
	lstrcpy( lf.lfFaceName, "lr " );
	hFontZen = CreateFontIndirect( &lf );

	lf.lfCharSet = ANSI_CHARSET;
	lstrcpy( lf.lfFaceName, "Courier New" );
	hFontHan = CreateFontIndirect( &lf );

	lf.lfHeight = 18;
	lf.lfWeight = 700;
	lf.lfItalic = TRUE;
	lstrcpy( lf.lfFaceName, "Times New Roman" );
	hFontVer = CreateFontIndirect( &lf );

	lpszTitle = strrchr( ac->szFileName, '\\' );
	if ( lpszTitle == NULL ) {
		lpszTitle = ac->szFileName;
	} else {
		lpszTitle++;
	}
	SelectObject( hDcMem, hFontTtl );
	GetTextExtentPoint32( hDcMem, lpszTitle, lstrlen(lpszTitle), &size );
	nPos = (WA4SZ / 2) - (size.cx / 2);
	TextOut( hDcMem, nPos, A4T + BDR, lpszTitle, lstrlen(lpszTitle) );

	lstrcpy( ac->szMessage, "VisualSpice Ver0.94 Copyright  1997 CRAFTWORK-JAPAN/THNNK!" );
	SelectObject( hDcMem, hFontVer );
	GetTextExtentPoint32( hDcMem, ac->szMessage, lstrlen(ac->szMessage), &size );
	nPos = A4R - size.cx;
	TextOut( hDcMem, nPos, A4B + BDR, ac->szMessage, lstrlen(ac->szMessage) );

	wsprintf( ac->szMessage, "PAGE:%03d ", nPage );
	SelectObject( hDcMem, hFontHan );
	GetTextExtentPoint32( hDcMem, ac->szMessage, lstrlen(ac->szMessage), &size );
	nPos = A4R - size.cx;
	TextOut( hDcMem, nPos, A4T + TTL - size.cy, ac->szMessage, strlen(ac->szMessage) );
	nPos++;
	TextOut( hDcMem, nPos, A4T + TTL - size.cy, ac->szMessage, strlen(ac->szMessage) );

	bRes = TRUE;
	nPos = A4T + TTL + BDR;
	do {
		LPCSTR lpszLine;

		lpszLine = GetLine( lpszText );
		if ( lpszLine ) {
			wsprintf( ac->szMessage, "%05d : %s", ++nLine, lpszLine );
			DrawLine( hDcMem, hFontZen, hFontHan, nPos, ac->szMessage );
			nPos += size.cy;
			lpszText = NULL;
		} else {
			bRes = FALSE;
		}
	} while ( nPos < A4B && bRes );

	BitBlt( hDcPrn, 0, 0, WA4SZ, HA4SZ, hDcMem, 0, 0, SRCCOPY );

	wsprintf( ac->szMessage, "%dy[W_Of[^v^hCoɓ]...", nPage );
	SendMessage( ac->hWndStat, SB_SETTEXT, SBT_NOBORDERS, (LPARAM)ac->szMessage );

	StartPage( hDC );
	StretchBlt( hDC, 0, 0, dwWidth, dwHeight, hDcPrn, 0, 0, WA4SZ, HA4SZ, SRCCOPY );
	EndPage( hDC );

	DeleteDC( hDcMem );
	DeleteDC( hDcPrn );
	DeleteObject( hFontZen );
	DeleteObject( hFontHan );
	DeleteObject( hFontTtl );
	DeleteObject( hFontVer );
	DeleteObject( hBmpMem );
	DeleteObject( hBmpPrn );
	DeleteObject( hPen );

	return bRes;
}